#include "rtq.h"
#define P( num ) Parms[ num ]->ToInt()
#define PS( num ) Parms[ num ]->ToStr()
#define Res LastUserFuncResult
#define Return(x) LastUserFuncResult = x;
#define ATTR(x) GetIntAttr(0, #x)
#define HAS_ATTR(x) HasAttr(0, #x)
#define SET_ATTR(x, y) SetIntAttr(0, #x, y)
#define ATTRS(x) GetStringAttr(0, #x)
#define SET_ATTRS(x, y) SetStringAttr(0, #x, y)
#include "intstrp.h"

void UserFunc(short IDCode, short ParmCount, IntStrPair **Parms, IntStrPair &LastUserFuncResult)
{
  Res = 0;
  switch (IDCode)
  {
    case ParStartParsing_:
      {
        #define FileName PS(0)

         Parser *Par = new Parser(FileName, false);
         Return((LLong)Par)

        #undef FileName
        break;
      }
    case ParStopParsing_:
      {
        #define Handle P(0)

        delete (Parser *)Handle;

        #undef Handle
        break;
      }
    case ParTestIdent_:
      {
        #define Handle P(0)
        #define Ident PS(1)
        #define DoAccept P(2)

        Parser *Par = (Parser *)Handle;
        Return(Par->TestIdent(Ident, DoAccept) ? Yes_ : No_)

        #undef Handle
        #undef Ident
        #undef DoAccept
        break;
      }
    case ParReadIdent_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        char IdentBuf[64];
        Par->ReadIdent(IdentBuf);
        
        Return(IdentBuf);

        #undef Handle
        break;
      }
    case ParSkipIdentsUntil_:
      {
        #define Handle P(0)
        #define Ident PS(1)
        #define DoAccept P(2)

        Parser *Par = (Parser *)Handle;
        Par->SkipIdentsUntil(Ident, DoAccept);
        Return(Par->TestEOF() ? No_ : Yes_)

        #undef Handle
        #undef Ident
        #undef DoAccept
        break;
      }
    case ParSkipAnyIdent_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        Par->SkipAnyIdent();

        #undef Handle
        break;
      }
    case ParReadString_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        
        char *Str = new char[512];  
        Par->ReadString(Str);
        
        Return(Str)
        delete Str;

        #undef Handle
        break;
      }
    case ParReadInt_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        Return(Par->ReadInt())

        #undef Handle
        break;
      }
    case ParReadFloatX100_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        Return((int)(100.0f*Par->ReadFloat()))

        #undef Handle
        break;
      }
    case ParWereErrors_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        
        Return(Par->WereErrors() ? Yes_ : No_)

        #undef Handle
        break;
      }
    case ParTestEOF_:
      {
        #define Handle P(0)

        Parser *Par = (Parser *)Handle;
        
        Return(Par->TestEOF() ? Yes_ : No_)

        #undef Handle
        break;
      }
    case ParIntToken_:
      {
        #define Handle P(0)
        #define Token PS(1)
        #define Value P(2)

        Parser *Par = (Parser *)Handle;
        
        Par->IntToken(Token, Value);

        #undef Handle
        #undef Token
        #undef Value
        break;
      }
    case ParStringToken_:
      {
        #define Handle P(0)
        #define Token PS(1)
        #define Value PS(2)

        Parser *Par = (Parser *)Handle;
        
        Par->StringToken(Token, Value);

        #undef Handle
        #undef Token
        #undef Value
        break;
      }
    case ParFloatTokenX100_:
      {
        #define Handle P(0)
        #define Token PS(1)
        #define Value P(2)

        Parser *Par = (Parser *)Handle;
        
        Par->FloatToken(Token, ((float)Value)/100.0f);

        #undef Handle
        #undef Token
        #undef Value
        break;
      }
    case ParGetIntValue_:
      {
        #define Handle P(0)
        #define Token PS(1)

        Parser *Par = (Parser *)Handle;

        Return(Par->GetIntValue(Token))

        #undef Handle
        #undef Token
        break;
      }
    case UFSetVersionString_:
      {
        #define Text PS(0)

    strcpy(VersionString, Text);

        #undef Text
        break;
      }
    case UFDump_:
      {
        #define Message PS(0)

//  FILE *f = fopen("/sdcard/a/e1q.dmp", "at");
//  fprintf(f, "%s\n", Message);
//  fclose(f);

    Trace("%s\n", Message);

        #undef Message
        break;
      }
    case UFGetCtrlKeyName_:
      {

#ifdef ALLEGRO_MACOSX
    Return("Cmd")
#else
    Return("Ctrl")
#endif

        break;
      }
    case RND_:
      {
        #define Min P(0)
        #define Max P(1)

    int Diff = Max-Min;
    
    if (Diff>0)
    {

      Return((LLong)((rand() % Diff) + Min))
    }
    else
    {
      Return(Min)
    }

        #undef Min
        #undef Max
        break;
      }
    case UFGenRandomIndex_:
      {
        #define _ShipHandle P(0)
        #define _StarHandle P(1)
        #define _PlanetHandle P(2)

    SpaceShip *Sh = (SpaceShip*)_ShipHandle;
    Star *S = (Star*)_StarHandle;
    Planet *TargetPlanet = (Planet*)_PlanetHandle;

    Return(GenRandomIndex(0xF, Sh, S, TargetPlanet))

        #undef _ShipHandle
        #undef _StarHandle
        #undef _PlanetHandle
        break;
      }
    case RND_INDEXED_:
      {
        #define Index P(0)
        #define Min P(1)
        #define Max P(2)

    int Diff = Max-Min;
    
    if (Diff>0)
    {
      Return((LLong)((GetRandom(Index) % Diff) + Min))
    }
    else
    {
      Return(Min)
    }

        #undef Index
        #undef Min
        #undef Max
        break;
      }
    case SQRT_:
      {
        #define Val P(0)

  Return((LLong)sqrt((float)Val))

        #undef Val
        break;
      }
    case DivRound_:
      {
        #define Val1 P(0)
        #define Val2 P(1)

  float Val1f = Val1;
  float Val2f = Val2;

  if (Val2f>0.0f)
  {
    Return(round_float(Val1f/Val2f);)
  }
  else
  {
    Return(0)
  }

        #undef Val1
        #undef Val2
        break;
      }
    case UFExchangeInt_:
      {
        #define IntValue P(0)

        E1PExchange.Idle = false;
        E1PExchange.Value = IntValue;

        #undef IntValue
        break;
      }
    case UFExchangeDoubleInt_:
      {
        #define IntValue P(0)
        #define IntValue1 P(1)

        E1PExchange.Idle = false;
        E1PExchange.Value = IntValue;
        E1PExchange.Value1 = IntValue1;

        #undef IntValue
        #undef IntValue1
        break;
      }
    case UFExchangeString_:
      {
        #define DescriptionText PS(0)

        E1PExchange.Idle = false;
        E1PExchange.SetString(DescriptionText);

        #undef DescriptionText
        break;
      }
    case UFExchangeSplit_:
      {
        #define DescriptionText PS(0)

        if (E1PExchange.Idle)
          E1PExchange.Flush();

        E1PExchange.Idle = false;
        E1PExchange.AddSplit(DescriptionText);

        #undef DescriptionText
        break;
      }
    case UFExchangeFileSplit_:
      {
        #define FileName PS(0)
        #define UseLocale P(1)

        E1PExchange.Flush();
        E1PExchange.Idle = false;
        E1PExchange.AddSplitFromFile(FileName, Yes_==UseLocale);

        #undef FileName
        #undef UseLocale
        break;
      }
    case UFSwitchSecondTimer_:
      {
        #define TimerOn P(0)

        ThrowTimer2Event = (Yes_==TimerOn);
        LastTimer2Tick = global_ticks;

        #undef TimerOn
        break;
      }
    case UFWinGame_:
      {
        #define ImageFile PS(0)
        #define TextFile PS(1)

        gState = GameState::GameWon;
        WinLoseInfoImage = ImageFile;
        WinLoseInfoText = TextFile;

        #undef ImageFile
        #undef TextFile
        break;
      }
    case UFLoseGame_:
      {
        #define ImageFile PS(0)
        #define TextFile PS(1)

        gState = GameState::GameLost;
        WinLoseInfoImage = ImageFile;
        WinLoseInfoText = TextFile;

        #undef ImageFile
        #undef TextFile
        break;
      }
    case UFSetAICheckInterval_:
      {
        #define ConstInterval P(0)
        #define RandInterval P(1)

        SetAICheckInterval(ConstInterval, RandInterval);

        #undef ConstInterval
        #undef RandInterval
        break;
      }
    case UFGetAISkill_:
      {

        Return(AISkill)

        break;
      }
    case UFResetGlobalMap_:
      {

    Galaxy::SegVis->ResetTransformThisTurn = true;

        break;
      }
    case UFGlobalMapFitZoom_:
      {

    Galaxy::SegVis->FrameOwnStarsThisTurn = true;

        break;
      }
    case UFShowStarSystemOfPlayer_:
      {
        #define WStar P(0)

    AddShowStarSystemOfPlayerButton((Star*)WStar);

        #undef WStar
        break;
      }
    case UFShowTargetStarAndStartStar_:
      {
        #define TargetStar P(0)
        #define StartStar P(1)

    AddShowTargetStarAndStartStarButton((Star*)TargetStar, (Star*)StartStar);

        #undef TargetStar
        #undef StartStar
        break;
      }
    case UFSelectStarSystemOfPlayerEnemies_:
      {

    Return((LLong)SelectStarSystemOfRace(RaceInfo[PlayerRace].Enemies, PlayerRace, PlayerRace));

        break;
      }
    case UFSelectStarSystemOfRace_:
      {
        #define WRace P(0)
        #define AdjToRace P(1)
        #define CheckVisitedByRace P(2)

    // allows to select one Star system of WRace that is adjustment to AdjToRace systems
    Return((LLong)SelectStarSystemOfRace(Bit(WRace), AdjToRace, CheckVisitedByRace));

        #undef WRace
        #undef AdjToRace
        #undef CheckVisitedByRace
        break;
      }
    case UFSelectStarSystemOfRacesBitscale_:
      {
        #define RacesBitscale P(0)
        #define AdjToRace P(1)
        #define CheckVisitedByRace P(2)

    // allows to select one Star system of WRace that is adjustment to AdjToRace systems
    Return((LLong)SelectStarSystemOfRace(RacesBitscale, AdjToRace, CheckVisitedByRace));

        #undef RacesBitscale
        #undef AdjToRace
        #undef CheckVisitedByRace
        break;
      }
    case UFGetNumberOfAdjustedSystems_:
      {
        #define WRace P(0)
        #define AdjToRace P(1)
        #define CheckVisitedByRace P(2)

    // gets the number of Star systems of WRace that is adjustment to AdjToRace systems
    Return(GetNumberOfAdjustedSystems(Bit(WRace), AdjToRace, CheckVisitedByRace));

        #undef WRace
        #undef AdjToRace
        #undef CheckVisitedByRace
        break;
      }
    case UFGetNumberOfEnemyAdjustedSystems_:
      {

    Return(GetNumberOfAdjustedSystems(RaceInfo[PlayerRace].Enemies, PlayerRace, PlayerRace));

        break;
      }
    case UFGetNumberOfAdjustedSystemsByBitscale_:
      {
        #define RacesBitscale P(0)
        #define AdjToRace P(1)
        #define CheckVisitedByRace P(2)

    // gets the number of Star systems of WRace that is adjustment to AdjToRace systems
    Return(GetNumberOfAdjustedSystems(RacesBitscale, AdjToRace, CheckVisitedByRace));

        #undef RacesBitscale
        #undef AdjToRace
        #undef CheckVisitedByRace
        break;
      }
    case UFSelectOneFleetOfRace_:
      {
        #define WRace P(0)

    Return((LLong)SelectOneFleetOfRace(WRace));

        #undef WRace
        break;
      }
    case UFInputNumber_:
      {
        #define InitialValue P(0)

    Res = EnterStringDialog(InitialValue);
    Res.ToInt();

        #undef InitialValue
        break;
      }
    case UFInputString_:
      {
        #define InitialValue PS(0)

    Res = EnterStringDialog((char*)(const char*)InitialValue);

        #undef InitialValue
        break;
      }
    case UFGetScreenSizeX_:
      {

    Return(Screen.Size.x)

        break;
      }
    case UFGetScreenSizeY_:
      {

    Return(Screen.Size.y)

        break;
      }
    case UFGetResizeX_:
      {
        #define X P(0)

    Return(round_float((float)X*RResizeX))

        #undef X
        break;
      }
    case UFGetResizeY_:
      {
        #define Y P(0)

    Return(round_float((float)Y*RResizeY))

        #undef Y
        break;
      }
    case UFIsGamePaused_:
      {

    Return(GalaxyGamePaused() ? Yes_ : No_)

        break;
      }
    case UFIsBattlePaused_:
      {

    Return(GamePaused() ? Yes_ : No_)

        break;
      }
    case UFPauseGame_:
      {

    GalClockPause(true);

        break;
      }
    case UFPauseBattle_:
      {

    Pause();

        break;
      }
    case UFUnpauseGame_:
      {

    GalClockPause(false);

        break;
      }
    case UFUnpauseBattle_:
      {

    Unpause();

        break;
      }
    case UFGetGameSpeed_:
      {

    Return(GalGetCurrentTimeScale());

        break;
      }
    case UFGetBattleSpeed_:
      {

    Return(RealGameSpeed());

        break;
      }
    case UFSetGameSpeed_:
      {
        #define NewSpeed P(0)

    GalSetCurrentTimeScale(NewSpeed);

        #undef NewSpeed
        break;
      }
    case UFSetBattleSpeed_:
      {
        #define NewSpeed P(0)

    SetRealGameSpeed(NewSpeed);

        #undef NewSpeed
        break;
      }
    case UFChoiceHelperPopup_:
      {
        #define Code P(0)
        #define HelperText PS(1)

    SetPopupHelperForAskChoice(Code, (const char*)HelperText);

        #undef Code
        #undef HelperText
        break;
      }
    case UFSetGameTimeScale_:
      {
        #define NewScale P(0)

    if (NewScale>=1)
      Galaxy::DrawTimeInfo.TimeScale = NewScale; // the default is 3 * 24 * 60;;

        #undef NewScale
        break;
      }
    case UFSetGameStartYearAndTime_:
      {
        #define _StartYear P(0)
        #define _StartTime P(1)

      Galaxy::DrawTimeInfo.StartYear = _StartYear; // the default is 2030
      Galaxy::DrawTimeInfo.StartTime = _StartTime; // the default is 2269 (in ticks)

        #undef _StartYear
        #undef _StartTime
        break;
      }
    case UFSetFullDateStringFormat_:
      {
        #define PrintYears P(0)
        #define PrintMonths P(1)
        #define PrintDays P(2)
        #define PrintHours P(3)
        #define PrintMinutes P(4)
        #define _ShortMonth P(5)

      // full date is used primarily for clocks and saves
      Galaxy::DrawTimeInfo.FullDateSettings.DrawYears = (Yes_==PrintYears); // the default is true
      Galaxy::DrawTimeInfo.FullDateSettings.DrawMonths = (Yes_==PrintMonths); // the default is true
      Galaxy::DrawTimeInfo.FullDateSettings.DrawDays = (Yes_==PrintDays); // the default is true
      Galaxy::DrawTimeInfo.FullDateSettings.DrawHours = (Yes_==PrintHours); // the default is false
      Galaxy::DrawTimeInfo.FullDateSettings.DrawMinutes = (Yes_==PrintMinutes); // the default is false

      Galaxy::DrawTimeInfo.FullDateSettings.ShortMonths = (Yes_==_ShortMonth); // the default is false

        #undef PrintYears
        #undef PrintMonths
        #undef PrintDays
        #undef PrintHours
        #undef PrintMinutes
        #undef _ShortMonth
        break;
      }
    case UFSetShortDateStringFormat_:
      {
        #define PrintYears P(0)
        #define PrintMonths P(1)
        #define PrintDays P(2)
        #define PrintHours P(3)
        #define PrintMinutes P(4)
        #define _ShortMonth P(5)

      // used primarily for events
      Galaxy::DrawTimeInfo.ShortDateSettings.DrawYears = (Yes_==PrintYears); // the default is true
      Galaxy::DrawTimeInfo.ShortDateSettings.DrawMonths = (Yes_==PrintMonths); // the default is false
      Galaxy::DrawTimeInfo.ShortDateSettings.DrawDays = (Yes_==PrintDays); // the default is false
      Galaxy::DrawTimeInfo.ShortDateSettings.DrawHours = (Yes_==PrintHours); // the default is false
      Galaxy::DrawTimeInfo.ShortDateSettings.DrawMinutes = (Yes_==PrintMinutes); // the default is false

      Galaxy::DrawTimeInfo.ShortDateSettings.ShortMonths = (Yes_==_ShortMonth); // the default is false

        #undef PrintYears
        #undef PrintMonths
        #undef PrintDays
        #undef PrintHours
        #undef PrintMinutes
        #undef _ShortMonth
        break;
      }
    case UFSetFullDurationStringFormat_:
      {
        #define PrintYears P(0)
        #define PrintMonths P(1)
        #define PrintDays P(2)
        #define PrintHours P(3)
        #define PrintMinutes P(4)

      // full date is used primarily for travel time
      Galaxy::DrawTimeInfo.FullDurationSettings.DrawYears = (Yes_==PrintYears); // the default is true
      Galaxy::DrawTimeInfo.FullDurationSettings.DrawMonths = (Yes_==PrintMonths); // the default is true
      Galaxy::DrawTimeInfo.FullDurationSettings.DrawDays = (Yes_==PrintDays); // the default is true
      Galaxy::DrawTimeInfo.FullDurationSettings.DrawHours = (Yes_==PrintHours); // the default is false
      Galaxy::DrawTimeInfo.FullDurationSettings.DrawMinutes = (Yes_==PrintMinutes); // the default is false

        #undef PrintYears
        #undef PrintMonths
        #undef PrintDays
        #undef PrintHours
        #undef PrintMinutes
        break;
      }
    case UFSetShortDurationStringFormat_:
      {
        #define PrintYears P(0)
        #define PrintMonths P(1)
        #define PrintDays P(2)
        #define PrintHours P(3)
        #define PrintMinutes P(4)

      // used primarily for construction time
      Galaxy::DrawTimeInfo.ShortDurationSettings.DrawYears = (Yes_==PrintYears); // the default is true
      Galaxy::DrawTimeInfo.ShortDurationSettings.DrawMonths = (Yes_==PrintMonths); // the default is true
      Galaxy::DrawTimeInfo.ShortDurationSettings.DrawDays = (Yes_==PrintDays); // the default is false
      Galaxy::DrawTimeInfo.ShortDurationSettings.DrawHours = (Yes_==PrintHours); // the default is false
      Galaxy::DrawTimeInfo.ShortDurationSettings.DrawMinutes = (Yes_==PrintMinutes); // the default is false

        #undef PrintYears
        #undef PrintMonths
        #undef PrintDays
        #undef PrintHours
        #undef PrintMinutes
        break;
      }
    case UFSetAltShortDurationStringFormat_:
      {
        #define PrintYears P(0)
        #define PrintMonths P(1)
        #define PrintDays P(2)
        #define PrintHours P(3)
        #define PrintMinutes P(4)

      // used instead of ShortDurationSettings when Print Build Time In Months setting is set to true
      Galaxy::DrawTimeInfo.AltShortDurationSettings.DrawYears = (Yes_==PrintYears); // the default is false
      Galaxy::DrawTimeInfo.AltShortDurationSettings.DrawMonths = (Yes_==PrintMonths); // the default is true
      Galaxy::DrawTimeInfo.AltShortDurationSettings.DrawDays = (Yes_==PrintDays); // the default is false
      Galaxy::DrawTimeInfo.AltShortDurationSettings.DrawHours = (Yes_==PrintHours); // the default is false
      Galaxy::DrawTimeInfo.AltShortDurationSettings.DrawMinutes = (Yes_==PrintMinutes); // the default is false

        #undef PrintYears
        #undef PrintMonths
        #undef PrintDays
        #undef PrintHours
        #undef PrintMinutes
        break;
      }
    case UFAddReportedMilestone_:
      {
        #define _Descr PS(0)
        #define _Text PS(1)
        #define StarHandle P(2)
        #define SelectStarHandle P(3)

  Star *S = (Star*)StarHandle;
  Star *SSel = (Star*)SelectStarHandle;

  new MilestonesHistoryStruct(_Descr, _Text, S, SSel);

        #undef _Descr
        #undef _Text
        #undef StarHandle
        #undef SelectStarHandle
        break;
      }
    case UFAddMilestone_:
      {
        #define _Descr PS(0)

  new MilestonesHistoryStruct(_Descr);

        #undef _Descr
        break;
      }
    case UFPlaySound_:
      {
        #define SoundName PS(0)

  new MilestonesHistoryStruct(_Descr);

        #undef SoundName
        break;
      }
    case UFRegisterBonus_:
      {
        #define ID P(0)
        #define Name PS(1)
        #define WeakestValue P(2)
        #define WeakerValue P(3)
        #define BetterValue P(4)
        #define BestValue P(5)

    RacialBonusData[ID].Set(Name, WeakestValue, WeakerValue, BetterValue, BestValue);

        #undef ID
        #undef Name
        #undef WeakestValue
        #undef WeakerValue
        #undef BetterValue
        #undef BestValue
        break;
      }
    case UFBonusHelper_:
      {
        #define ID P(0)
        #define FullDescription PS(1)
        #define WeakestValue PS(2)
        #define WeakerValue PS(3)
        #define BetterValue PS(4)
        #define BestValue PS(5)

    RacialBonusData[ID].SetHelper(FullDescription, WeakestValue, WeakerValue, BetterValue, BestValue);

        #undef ID
        #undef FullDescription
        #undef WeakestValue
        #undef WeakerValue
        #undef BetterValue
        #undef BestValue
        break;
      }
    case UFAddBonusOption_:
      {
        #define ID P(0)
        #define Name PS(1)
        #define Option PS(2)
        #define Value P(3)
        #define _FullDescription PS(4)

    RacialBonusData[ID].Options = new RacialBonusOptionInfo(Name, Option, Value, RacialBonusData[ID].Options);
    RacialBonusData[ID].Options->FullDescription = (const char*)_FullDescription;

        #undef ID
        #undef Name
        #undef Option
        #undef Value
        #undef _FullDescription
        break;
      }
    case UFResetSelectedBonuses_:
      {

    ResetSelectedBonuses();

        break;
      }
    case UFGetBonusSelected_:
      {
        #define ID P(0)

    Return(RacialBonusData[ID].SelectedVariant)

        #undef ID
        break;
      }
    case UFSetBonusSelected_:
      {
        #define ID P(0)
        #define Variant P(1)

    RacialBonusData[ID].SelectedVariant = Variant;

        #undef ID
        #undef Variant
        break;
      }
    case UFGetBonusSelectedNumOptions_:
      {
        #define ID P(0)

    int Count = 0;

    for (RacialBonusOptionInfo *Cur = RacialBonusData[ID].Options; Cur; Cur = Cur->Next)
      if (Cur->Selected)
        Count++;

    Return(Count)

        #undef ID
        break;
      }
    case UFGetBonusSelectedOption_:
      {
        #define ID P(0)
        #define Num P(1)


    int Count = Num;
    Res = "";

    for (RacialBonusOptionInfo *Cur = RacialBonusData[ID].Options; Cur; Cur = Cur->Next)
    {
      if (Cur->Selected)
      {
        if (Count<=0)
        {
          Res = (const char*)Cur->Option;
          break;
        }
        else
          Count--;
      }
    }

        #undef ID
        #undef Num
        break;
      }
    case UFSetBonusSelectedOption_:
      {
        #define ID P(0)
        #define Opt PS(1)


    for (RacialBonusOptionInfo *Cur = RacialBonusData[ID].Options; Cur; Cur = Cur->Next)
    {
      if (!strcmp((const char*)Opt, (const char*)Cur->Option))
      {
        Cur->Selected = true;
        break;
      }
    }

        #undef ID
        #undef Opt
        break;
      }
    case UFSetTotalBonusPoints_:
      {
        #define Total P(0)

    RacialBonusInfo::TotalBonusPoints = Total;

        #undef Total
        break;
      }
    case UFRegisterRace_:
      {
        #define WRace P(0)
        #define _RoomName PS(1)
        #define _Name PS(2)
        #define _Descr_Name PS(3)
        #define _Descr_Whoes PS(4)
        #define ShowInDiplomacy P(5)
        #define ShowInStatistics P(6)

        Race::RegisterNewRace(WRace, _RoomName, _Name, _Descr_Name, _Descr_Whoes, (Yes_==ShowInDiplomacy), (Yes_==ShowInStatistics));

        #undef WRace
        #undef _RoomName
        #undef _Name
        #undef _Descr_Name
        #undef _Descr_Whoes
        #undef ShowInDiplomacy
        #undef ShowInStatistics
        break;
      }
    case UFRaceShowInDiplomacy_:
      {
        #define WRace P(0)
        #define _ShowInDiplomacy P(1)
        #define _ShowInStatistics P(2)

        RaceInfo[WRace].ShowInDiplomacy = (Yes_==_ShowInDiplomacy);
        RaceInfo[WRace].ShowInStatistics = (Yes_==_ShowInStatistics);

        #undef WRace
        #undef _ShowInDiplomacy
        #undef _ShowInStatistics
        break;
      }
    case UFInitRaceDoctrines_:
      {
        #define WRace P(0)
        #define _DoctrineINI PS(1)

        ClearListSTD(DoctrineStruct, GetRaceInfo(WRace).Doctrines);
        GetRaceInfo(WRace).DoctrineName = _DoctrineINI;

        #undef WRace
        #undef _DoctrineINI
        break;
      }
    case UFSetRaceIcon_:
      {
        #define WRace P(0)
        #define _RaceIcon PS(1)

        GetRaceInfo(WRace).Icon = GetGif(_RaceIcon);
        if (RaceStatus::RaceIconAtlas)
          RaceStatus::RaceIconAtlas->ForceRebuild();

        #undef WRace
        #undef _RaceIcon
        break;
      }
    case UFModifyRaceDoctrineInvasionProb_:
      {
        #define WRace P(0)
        #define PlayerProb P(1)
        #define AIProb P(2)

        GetRaceInfo(WRace).ModifyInvasionProb(PlayerProb*10, AIProb*10);

        #undef WRace
        #undef PlayerProb
        #undef AIProb
        break;
      }
    case UFMarkFullRace_:
      {
        #define WRace P(0)

        SetBit(Race::FullRacesBitscale, WRace);
        
        Race::NumberRealRaces = 0;

        for (int i = 0; i<Race::Number; i++)
          if (GetBit(Race::FullRacesBitscale, i))
            Race::NumberRealRaces++;

        #undef WRace
        break;
      }
    case UFMarkPlayableRace_:
      {
        #define WRace P(0)

        SetBit(Race::PlayableRacesBitscale, WRace);

        #undef WRace
        break;
      }
    case UFSetCanExistWithoutPlanets_:
      {
        #define WRace P(0)
        #define Value P(1)

        GetRaceInfo(WRace).CanExistWithoutPlanets = (Yes_==Value);

        #undef WRace
        #undef Value
        break;
      }
    case UFSetRelations_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define NewValue P(2)

        CheckRaces(WRace1);

        GetRaceInfo(WRace).SetRelations(WRace1, NewValue, E1_UNDEFINED);
//        RaceInfo[WRace1].Relations[WRace] = NewValue;

        #undef WRace
        #undef WRace1
        #undef NewValue
        break;
      }
    case UFSetRelationsWithReason_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define NewValue P(2)
        #define Reason P(3)

        CheckRaces(WRace1);

        GetRaceInfo(WRace).SetRelations(WRace1, NewValue, Reason);
//        RaceInfo[WRace1].Relations[WRace] = NewValue;

        #undef WRace
        #undef WRace1
        #undef NewValue
        #undef Reason
        break;
      }
    case UFGetRelations_:
      {
        #define WRace P(0)
        #define WRace1 P(1)

        CheckRaces(WRace1);

        Return(GetRaceInfo(WRace).GetRelations(WRace1));

        #undef WRace
        #undef WRace1
        break;
      }
    case UFHasRelationsReason_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define TimeToSearch P(2)
        #define Reason P(3)

        CheckRaces(WRace1);

        if (GetRaceInfo(WRace).HasRelationsReason(WRace1, TimeToSearch, Reason, E1_UNDEFINED))
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef WRace
        #undef WRace1
        #undef TimeToSearch
        #undef Reason
        break;
      }
    case UFHasRelationsReasonWithBlocking_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define TimeToSearch P(2)
        #define Reason P(3)
        #define BlockingReason P(4)

        CheckRaces(WRace1);

        if (GetRaceInfo(WRace).HasRelationsReason(WRace1, TimeToSearch, Reason, BlockingReason))
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef WRace
        #undef WRace1
        #undef TimeToSearch
        #undef Reason
        #undef BlockingReason
        break;
      }
    case UFAddRelationsEvent_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define EventCode P(2)

        CheckRaces(WRace1);

        GetRaceInfo(WRace).RelationsHistory[WRace1] = new RelationsHistoryStruct(Galaxy::Time, 0, EventCode, GetRaceInfo(WRace).RelationsHistory[WRace1]);

        #undef WRace
        #undef WRace1
        #undef EventCode
        break;
      }
    case UFGetRelationsTimeFromEvent_:
      {
        #define WRace P(0)
        #define WRace1 P(1)
        #define EventCode P(2)

        CheckRaces(WRace1);

        Return(GetRaceInfo(WRace).GetTimeFromEvent(WRace1, EventCode));

        #undef WRace
        #undef WRace1
        #undef EventCode
        break;
      }
    case UFSetRaceImages_:
      {
        #define RID P(0)
        #define faceImage PS(1)
        #define bigImage PS(2)

        GetRaceInfo(RID).SetFaceImage(faceImage);
        GetRaceInfo(RID).SetBigImage(bigImage);

        #undef RID
        #undef faceImage
        #undef bigImage
        break;
      }
    case UFAddIdleVideo_:
      {
        #define RID P(0)
        #define VideoPath PS(1)
        #define Probability P(2)

        GetRaceInfo(RID).AddIdleVideo(VideoPath, Probability);

        #undef RID
        #undef VideoPath
        #undef Probability
        break;
      }
    case UFAddTalkingVideo_:
      {
        #define RID P(0)
        #define VideoPath PS(1)

        GetRaceInfo(RID).AddTalkingVideo(VideoPath);

        #undef RID
        #undef VideoPath
        break;
      }
    case UFSetRaceMusic_:
      {
        #define RID P(0)
        #define MusicName PS(1)

        strcpy(GetRaceInfo(RID).SongName, MusicName);

        #undef RID
        #undef MusicName
        break;
      }
    case UFSetRaceColor_:
      {
        #define RID P(0)
        #define RGB PS(1)

        GetRaceInfo(RID).SetColor(RGB); // format #rrggbb - in Hex

        #undef RID
        #undef RGB
        break;
      }
    case UFSetRaceName_:
      {
        #define RID P(0)
        #define Name PS(1)

        strcpy(GetRaceInfo(RID).descr_name, (const char*)Name);

        #undef RID
        #undef Name
        break;
      }
    case UFSetRaceLocalAI_:
      {
        #define RID P(0)
        #define LocalAI P(1)

        GetRaceInfo(RID).AIHandledExternally = (Yes_ == LocalAI);

        #undef RID
        #undef LocalAI
        break;
      }
    case UFSetRaceLocalPlanetECO_:
      {
        #define RID P(0)
        #define LocalECO P(1)

        GetRaceInfo(RID).ECOHandledExternally = (Yes_ == LocalECO);

        #undef RID
        #undef LocalECO
        break;
      }
    case UFAddDesignName_:
      {
        #define RID P(0)
        #define DName PS(1)

        GetRaceInfo(RID).AddDesignName(DName);

        #undef RID
        #undef DName
        break;
      }
    case UFSetPopulationGrowthParameters_:
      {
        #define RID P(0)
        #define Multiplier P(1)
        #define Addition P(2)

        GetRaceInfo(RID).PopulationGrowthMultiplier = Multiplier;
        GetRaceInfo(RID).PopulationGrowthMultiplier/=100000.0f;
        
        if (GetRaceInfo(RID).PopulationGrowthMultiplier<0.75f)
          GetRaceInfo(RID).PopulationGrowthMultiplier = 0.75f;
          
        GetRaceInfo(RID).PopulationGrowthAddition = Addition;

        #undef RID
        #undef Multiplier
        #undef Addition
        break;
      }
    case UFSetHappinessParameters_:
      {
        #define RID P(0)
        #define MinLevel P(1)
        #define TurnsBeforeRevolt P(2)
        #define TurnsBeforeSeparation P(3)

        GetRaceInfo(RID).UnhappyTurnsBeforeRevolt = TurnsBeforeRevolt;
        GetRaceInfo(RID).MinHappinessLevel = (float)(MinLevel)/100.0f;
        GetRaceInfo(RID).RevoltTurnsBeforeSeparation = TurnsBeforeSeparation;

        #undef RID
        #undef MinLevel
        #undef TurnsBeforeRevolt
        #undef TurnsBeforeSeparation
        break;
      }
    case UFSetOvertimeHappinessCoeffs_:
      {
        #define RID P(0)
        #define Multiplier P(1)
        #define Adder P(2)

        GetRaceInfo(RID).CoeffOHM = Multiplier;
        GetRaceInfo(RID).CoeffOHM/=100.0f;
        
        GetRaceInfo(RID).CoeffOHA = Adder;
        GetRaceInfo(RID).CoeffOHA/=100.0f;

        #undef RID
        #undef Multiplier
        #undef Adder
        break;
      }
    case UFSetGlobalHappinessCoeffs_:
      {
        #define RID P(0)
        #define Multiplier P(1)
        #define Adder P(2)

        GetRaceInfo(RID).CoeffGHM = Multiplier;
        GetRaceInfo(RID).CoeffGHM/=100.0f;
        
        GetRaceInfo(RID).CoeffGHA = Adder;
        GetRaceInfo(RID).CoeffGHA/=100.0f;

        #undef RID
        #undef Multiplier
        #undef Adder
        break;
      }
    case UFSetDangerHappinessCoeffs_:
      {
        #define RID P(0)
        #define Multiplier P(1)
        #define Adder P(2)

        GetRaceInfo(RID).CoeffDHM = Multiplier;
        GetRaceInfo(RID).CoeffDHM/=100.0f;
        
        GetRaceInfo(RID).CoeffDHA = Adder;
        GetRaceInfo(RID).CoeffDHA/=100.0f;

        #undef RID
        #undef Multiplier
        #undef Adder
        break;
      }
    case UFSetAssimilationHappinessCoeffs_:
      {
        #define RID P(0)
        #define Multiplier P(1)
        #define Adder P(2)

        GetRaceInfo(RID).CoeffAHM = Multiplier;
        GetRaceInfo(RID).CoeffAHM/=100.0f;
        
        GetRaceInfo(RID).CoeffAHA = Adder;
        GetRaceInfo(RID).CoeffAHA/=100.0f;

        #undef RID
        #undef Multiplier
        #undef Adder
        break;
      }
    case UFSetAssimilationParameters_:
      {
        #define RID P(0)
        #define OccupiedByRace P(1)
        #define MaxLevel P(2)
        #define MaxAssimilationYears P(3)

        GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace] = MaxLevel;
        GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace]/=100.0f;
        
        if (GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace]>1.0f)
          GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace] = 1.0f;
        else
          if (GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace]<0.0f)
            GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace] = 0.0f;
        
        float MonthsToAssimilate = MaxAssimilationYears * 12.0f;
        
        if (MonthsToAssimilate>0.0f)
          GetRaceInfo(RID).AssimilationSpeed[OccupiedByRace] = GetRaceInfo(RID).MaxAssimilationLevel[OccupiedByRace] / MonthsToAssimilate;
        else
          GetRaceInfo(RID).AssimilationSpeed[OccupiedByRace] = 1.0f;

        #undef RID
        #undef OccupiedByRace
        #undef MaxLevel
        #undef MaxAssimilationYears
        break;
      }
    case UFSetPopulationProductionToScienceSplit_:
      {
        #define RID P(0)
        #define Split P(1)

        float FSplit = Split;
        
        if (FSplit>100.0f)
          FSplit = 100.0f;
        else
          if (FSplit<0.0f)
            FSplit = 0.0f;

        GetRaceInfo(RID).ProductionToScienceSplit = FSplit / 100.0f;

        #undef RID
        #undef Split
        break;
      }
    case UFSetTalkingRace_:
      {
        #define WRace P(0)

        SetDiplomacyRace(WRace);

        #undef WRace
        break;
      }
    case UFSetTalkingVideo_:
      {
        #define VideoPath PS(0)

        SetDiplomacyTalkingVideo(VideoPath, true);

        #undef VideoPath
        break;
      }
    case UFSetNextTalkingVideo_:
      {
        #define VideoPath PS(0)

        SetDiplomacyTalkingVideo(VideoPath, false);

        #undef VideoPath
        break;
      }
    case UFSetRacePresent_:
      {
        #define WRace P(0)

        GetRaceInfo(WRace).PresentInGame = true;

        #undef WRace
        break;
      }
    case UFClearRacePresent_:
      {
        #define WRace P(0)

        GetRaceInfo(WRace).PresentInGame = false;

        #undef WRace
        break;
      }
    case UFClearRaceBits_:
      {
        #define WRace P(0)

        int WRaceInt = WRace;

        GetRaceInfo(WRaceInt).ResetBits();
              
        for (int i = 0; i<Race::MaxNumber; i++)
        {          
          RaceInfo[i].ClearAllies(WRaceInt);
          RaceInfo[i].ClearEnemies(WRaceInt);
          RaceInfo[i].SetPartners(WRaceInt, plNone_);
          RaceInfo[i].ClearKnownBy(WRaceInt);
          RaceInfo[i].ClearScientificTreaty(WRaceInt);
        }

        #undef WRace
        break;
      }
    case UFRacesMet_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race0);
        if (GetRaceInfo(Race1).GetKnownBy(Race0))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        #undef Race1
        break;
      }
    case UFClearRacesMet_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race0);
        CheckRaces(Race1);
        RaceInfo[Race0].ClearKnownBy(Race1);
        RaceInfo[Race1].ClearKnownBy(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFKnowsPlanetsOfRace_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        int Result = No_;

        ForEachStar(S)
        {
          if (GetBit(S->ProjectedPlanetOwners, (int)Race1) && S->OwnerKnownFor(Race0))
          {
            Result = Yes_;
            break;
          }
        }

        Return(Result);

        #undef Race0
        #undef Race1
        break;
      }
    case UFAreAllies_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);
        if (GetRaceInfo(Race0).IsAlly(Race1))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        #undef Race1
        break;
      }
    case UFRaceInWar_:
      {
        #define Race0 P(0)

        if (GetRaceInfo(Race0).HasEnemies())
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        break;
      }
    case UFAreEnemies_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        if (GetRaceInfo(Race0).IsEnemy(Race1))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }


        #undef Race0
        #undef Race1
        break;
      }
    case UFMakeWar_:
      {
        #define _Race0 P(0)
        #define _Race1 P(1)

        int Race0 = _Race0;
        int Race1 = _Race1;
        
        CheckRaces(Race1);

        if (!GetBit(GetRaceInfo(Race0).Enemies, Race1))
        {
          if (Race1==PlayerRace)
          {
            Race1 = Race0;
            Race0 = PlayerRace;
          }

          if (Race0 == PlayerRace )
          {
            JournalEvent(journalStartedWarAgainsPlayer_, Race1);
          }
          else
          if (cheatsEnabled || (GetRaceInfo(Race0).GetKnownBy(PlayerRace) && GetRaceInfo(Race1).GetKnownBy(PlayerRace)))
          {
            JournalEvent(journalStartedWarBetween_, Race0, Race1);
          }
        }

        GetRaceInfo(Race0).SetKnownBy(Race1);
        GetRaceInfo(Race1).SetKnownBy(Race0);
        
        GetRaceInfo(Race0).SetEnemies(Race1);
        GetRaceInfo(Race1).SetEnemies(Race0);

        GetRaceInfo(Race0).ClearAllies(Race1);
        GetRaceInfo(Race1).ClearAllies(Race0);

        GetRaceInfo(Race0).SetPartners(Race1, plNone_);
        GetRaceInfo(Race1).SetPartners(Race0, plNone_);

        GetRaceInfo(Race0).ClearScientificTreaty(Race1);
        GetRaceInfo(Race1).ClearScientificTreaty(Race0);

        GetRaceInfo(Race0).CancelTradeAgreements(Race1);
        GetRaceInfo(Race1).CancelTradeAgreements(Race0);

        #undef _Race0
        #undef _Race1
        break;
      }
    case UFMakePeace_:
      {
        #define Race0 P(0)
        #define Race1 P(1)


        CheckRaces(Race1);

        if (GetBit(GetRaceInfo(Race0).Enemies, Race1))
        {
          if (cheatsEnabled || (GetRaceInfo(Race0).GetKnownBy(PlayerRace) && GetRaceInfo(Race1).GetKnownBy(PlayerRace)))
          {
            JournalEvent(journalPeaceTreaty_, Race0, Race1);
          }
        }

        GetRaceInfo(Race0).ClearEnemies(Race1);
        GetRaceInfo(Race1).ClearEnemies(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFBreakAlliance_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        GetRaceInfo(Race0).ClearAllies(Race1);
        GetRaceInfo(Race1).ClearAllies(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFMakeAlliance_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        if (!GetBit(GetRaceInfo(Race0).Allies, Race1))
        {
          if (cheatsEnabled || (GetRaceInfo(Race0).GetKnownBy(PlayerRace) && GetRaceInfo(Race1).GetKnownBy(PlayerRace)))
          {
            JournalEvent(journalAllianceBetween_, Race0, Race1);
          }
        }

        GetRaceInfo(Race0).SetKnownBy(Race1);
        GetRaceInfo(Race1).SetKnownBy(Race0);
        
        GetRaceInfo(Race0).SetAllies(Race1);
        GetRaceInfo(Race1).SetAllies(Race0); 

        GetRaceInfo(Race0).SetPartners(Race1, plFullCooperation_);
        GetRaceInfo(Race1).SetPartners(Race0, plFullCooperation_);
        
        DeleteInvasionPlan(Race0, Race1);
        DeleteInvasionPlan(Race1, Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFSetMetRace_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        GetRaceInfo(Race0).SetKnownBy(Race1);
        GetRaceInfo(Race1).SetKnownBy(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFSetPartners_:
      {
        #define Race0 P(0)
        #define Race1 P(1)
        #define Level P(2)

        GetRaceInfo(Race0).SetPartners(Race1, Level);
        GetRaceInfo(Race1).SetPartners(Race0, Level);

        #undef Race0
        #undef Race1
        #undef Level
        break;
      }
    case UFGetPartnersLevel_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        Return(GetRaceInfo(Race0).GetPartners(Race1));

        #undef Race0
        #undef Race1
        break;
      }
    case UFStartScientificTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        GetRaceInfo(Race0).SetScientificTreaty(Race1);
        GetRaceInfo(Race1).SetScientificTreaty(Race0);        

        #undef Race0
        #undef Race1
        break;
      }
    case UFStopScientificTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        GetRaceInfo(Race0).ClearScientificTreaty(Race1);
        GetRaceInfo(Race1).ClearScientificTreaty(Race0);        

        #undef Race0
        #undef Race1
        break;
      }
    case UFHasScientificTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        if (GetRaceInfo(Race0).GetScientificTreaty(Race1))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        #undef Race1
        break;
      }
    case UFStartEconomicalTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        GetRaceInfo(Race0).SetEconomicalTreaty(Race1);
        GetRaceInfo(Race1).SetEconomicalTreaty(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFStopEconomicalTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        GetRaceInfo(Race0).ClearEconomicalTreaty(Race1);
        GetRaceInfo(Race1).ClearEconomicalTreaty(Race0);

        #undef Race0
        #undef Race1
        break;
      }
    case UFHasEconomicalTreaty_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        CheckRaces(Race1);

        if (GetRaceInfo(Race0).GetEconomicalTreaty(Race1))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        #undef Race1
        break;
      }
    case UFHasContracts_:
      {
        #define Race0 P(0)
        #define Race1 P(1)

        if (GetRaceInfo(Race0).HasTradeAgreements(Race1) || GetRaceInfo(Race1).HasTradeAgreements(Race0))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race0
        #undef Race1
        break;
      }
    case UFResetDesigns_:
      {
        #define WRace P(0)

        NullAllDesigns(WRace);

        #undef WRace
        break;
      }
    case UFHideCapitalShips_:
      {
        #define Race P(0)

        GetRaceInfo(Race).HideCapitalShips = true;

        #undef Race
        break;
      }
    case UFStopHidingCapitalShips_:
      {
        #define Race P(0)

        GetRaceInfo(Race).HideCapitalShips = false;

        #undef Race
        break;
      }
    case UFGetPlayerJointAttackDecision_:
      {
        #define Race P(0)
        #define StarHandle P(1)

        Star *S = (Star*)StarHandle;

        int Decision = GetRaceInfo(Race).GetJointAttackDecision(S);

        Return(Decision);

        #undef Race
        #undef StarHandle
        break;
      }
    case UFSetPlayerJointAttackDecision_:
      {
        #define Race P(0)
        #define StarHandle P(1)
        #define Decision P(2)

        Star *S = (Star*)StarHandle;

        GetRaceInfo(Race).SetJointAttackDecision(S, Decision);

        #undef Race
        #undef StarHandle
        #undef Decision
        break;
      }
    case UFSetTributeTo_:
      {
        #define Race P(0)
        #define RaceToPay P(1)
        #define Amount P(2)

        float fAmount = Amount;
        
        fAmount*=0.01f;

        CheckRaces(RaceToPay);

        GetRaceInfo(Race).TributeAmount[RaceToPay] = fAmount;

        #undef Race
        #undef RaceToPay
        #undef Amount
        break;
      }
    case UFGetTributeAmount_:
      {
        #define Race P(0)
        #define RaceToPay P(1)

        CheckRaces(RaceToPay);

        Return((LLong)(100*GetRaceInfo(Race).TributeAmount[RaceToPay]));

        #undef Race
        #undef RaceToPay
        break;
      }
    case UFGetGeneralDevelopmentIndex_:
      {
        #define RaceID P(0)

        RaceStatus *R = &GetRaceInfo(RaceID);
        int DevIndex = 1000.0f*R->GetGeneralDevelopmentIndex();

        Return(DevIndex)

        #undef RaceID
        break;
      }
    case UFGetNumOfStarsIndex_:
      {
        #define RaceID P(0)

        RaceStatus *R = &GetRaceInfo(RaceID);
        int DevIndex = 1000.0f*R->GetNumOfStarsIndex();

        Return(DevIndex)

        #undef RaceID
        break;
      }
    case UFGetNumOfStars_:
      {
        #define RaceID P(0)

        RaceStatus *R = &GetRaceInfo(RaceID);
        int DevIndex = R->GetNumOfStars();

        Return(DevIndex)

        #undef RaceID
        break;
      }
    case UFGetScienceIndex_:
      {
        #define RaceID P(0)

        RaceStatus *R = &GetRaceInfo(RaceID);
        int DevIndex = 100.0f*R->GetScienceIndex();

        Return(DevIndex)

        #undef RaceID
        break;
      }
    case UFGetTotalPopulation_:
      {
        #define RaceID P(0)

        int Count = 0;

        ForEachStar(S)
        {
          ForEachPlanet(S, Pl)
          {
            if (Pl->Owner==RaceID)
              Count+=Pl->BasePopulation;
          }
        }
        
        Return(Count)

        #undef RaceID
        break;
      }
    case UFGetTotalFleetPowerX100_:
      {
        #define RaceID P(0)

        float TotalAStr = 0;

        ForEachFleet(Fl)
        {
          if (RaceID==Fl->Owner || -1==RaceID)
          {
            if (!Fl->PhantomDisinfo)
            {
              float AStr;
              float DStr;

              GetFleetADStr(Fl, AStr, DStr);
              
              TotalAStr+=AStr;
            }
          }
        }
        
        TotalAStr*=100.0f;
        
        int TotalInt = TotalAStr;

        Return(TotalInt);

        #undef RaceID
        break;
      }
    case UFDisinfoAmplifierX100_:
      {
        #define RaceID P(0)
        #define UseFleet P(1)
        #define UseEconomy P(2)

        Return(100*(GetPlayerPowerAmplifier(RaceID, Yes_==UseFleet, Yes_==UseEconomy)))

        #undef RaceID
        #undef UseFleet
        #undef UseEconomy
        break;
      }
    case UFGetMonthlyProduction_:
      {
        #define WRace P(0)
        #define ResType P(1)
        #define Mult P(2)

        int Result = 0;
        float fMult = Mult;

        if (!GetRaceInfo(WRace).Stat)
          GetRaceInfo(WRace).StatisticsSnapshot(true);

        Result = fMult*GetRaceInfo(WRace).Stat->AllProduction[ResType];
        
        Return(Result)

        #undef WRace
        #undef ResType
        #undef Mult
        break;
      }
    case UFDeleteInvasionPlanIfNotEnemies_:
      {
        #define WRace P(0)

        DeleteInvasionPlanIfNotEnemies(WRace);

        #undef WRace
        break;
      }
    case UFDeleteInvasionPlansAgainst_:
      {
        #define WRace P(0)
        #define TargetRace P(1)

        DeleteInvasionPlan(WRace, TargetRace);

        #undef WRace
        #undef TargetRace
        break;
      }
    case UFCreateInvasionPlan_:
      {
        #define WRace P(0)
        #define StarHandle P(1)
        #define HelpingAlly P(2)

        if (TryCreateInvasionPlan(WRace, (Star*)StarHandle, Yes_==HelpingAlly))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef WRace
        #undef StarHandle
        #undef HelpingAlly
        break;
      }
    case UFGetPrimaryInvasionPlan_:
      {
        #define WRace P(0)

        Return((LLong)GetPrimaryInvasionPlan(WRace))

        #undef WRace
        break;
      }
    case UFInvasionPlanTarget_:
      {
        #define PlanHandle P(0)

        AIInvasionPlan *Plan = (AIInvasionPlan*)PlanHandle;

        if (Plan)
        {
          Return((LLong)Plan->Target)
        }
        else
        {
          Return(0)
        }

        #undef PlanHandle
        break;
      }
    case UFInvasionPlanStartStar_:
      {
        #define PlanHandle P(0)

        AIInvasionPlan *Plan = (AIInvasionPlan*)PlanHandle;

        if (Plan)
        {
          Return((LLong)Plan->StartStar)
        }
        else
        {
          Return(0)
        }

        #undef PlanHandle
        break;
      }
    case UFSetTargetTech_:
      {
        #define Race P(0)
        #define TechName PS(1)

        SetTargetTechnology(Race, TechName);        

        #undef Race
        #undef TechName
        break;
      }
    case UFGetTechnologyCost_:
      {
        #define Race P(0)
        #define TechName PS(1)

        Return(GetTechnologyCost(Race, TechName));

        #undef Race
        #undef TechName
        break;
      }
    case UFGetTechnologyCostByHandle_:
      {
        #define Race P(0)
        #define TechHandle P(1)

        Technology *tech = (Technology *)TechHandle;

        Return(GetTechnologyCost(Race, tech));

        #undef Race
        #undef TechHandle
        break;
      }
    case UFGetTechnologyCostInMineral_:
      {
        #define Race P(0)
        #define TechName PS(1)
        #define ResType P(2)
        #define Mult P(3)

        float Cost = GetTechnologyCostInMineral(Race, TechName, ResType)*Mult;

        Return(Cost);

        #undef Race
        #undef TechName
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetFullTechnologyCost_:
      {
        #define TechName PS(0)

        Return(GetTechnologyCost(Race::NoOnes, TechName));

        #undef TechName
        break;
      }
    case UFGetTechnologyName_:
      {
        #define TechNameInternal PS(0)

        Technology *tech = Find_Technology(TechNameInternal);
        
        if (tech)
        {
          Return(tech->descr_name);
        }
        else
        {
          Return(TechNameInternal);
        }

        #undef TechNameInternal
        break;
      }
    case UFGetTechnologyDescription_:
      {
        #define TechNameInternal PS(0)

        Technology *tech = Find_Technology(TechNameInternal);
        
        if (tech)
        {
          Return((const char*)tech->FullDescription);
        }
        else
        {
          Return(TechNameInternal);
        }

        #undef TechNameInternal
        break;
      }
    case UFIsKnownTech_:
      {
        #define Race P(0)
        #define TechName PS(1)

        Technology *tech = Find_Technology(TechName);
        
        if (tech && tech->Is_Available(Race))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race
        #undef TechName
        break;
      }
    case UFTechIsAvailable_:
      {
        #define Race P(0)
        #define TechHandle P(1)

        Technology *tech = (Technology *)TechHandle;
        
        if (tech && tech->Is_Available(Race))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race
        #undef TechHandle
        break;
      }
    case UFTechGetPointsResearched_:
      {
        #define Race P(0)
        #define TechHandle P(1)

        Technology *tech = (Technology *)TechHandle;
        
        if (tech)
        {
          Return(round_float(tech->points_researched[Race]));
        }
        else
        {
          Return(No_);
        }

        #undef Race
        #undef TechHandle
        break;
      }
    case UFIsFinalTech_:
      {
        #define TechName PS(0)

        Technology *tech = Find_Technology(TechName);
        
        if (tech && tech->FinalTechnology)
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef TechName
        break;
      }
    case UFIsFinalTechHandle_:
      {
        #define TechHandle P(0)

        Technology *tech = (Technology *)TechHandle;
        
        if (tech && tech->FinalTechnology)
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef TechHandle
        break;
      }
    case UFTechNeedToResearchFurther_:
      {
        #define Race P(0)
        #define TechName PS(1)

        Technology *tech = Find_Technology(TechName);
        
        if (tech && tech->NeedToResearchFurther(Race))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race
        #undef TechName
        break;
      }
    case UFGetTechHandle_:
      {
        #define TechName PS(0)

        Technology *tech = Find_Technology(TechName);
        Return((LLong)tech);

        #undef TechName
        break;
      }
    case UFGetTechID_:
      {
        #define TechHandle P(0)

        Technology *tech = (Technology*)TechHandle;

        Return(tech->_name);

        #undef TechHandle
        break;
      }
    case UFTechGetNumParents_:
      {
        #define TechHandle P(0)

        Technology *tech = (Technology*)TechHandle;
        
        if (tech)
        {
          Return(tech->parents_number);
        }
        else
        {
          Return(0);
        }

        #undef TechHandle
        break;
      }
    case UFTechGetParent_:
      {
        #define TechHandle P(0)
        #define N P(1)

        Technology *tech = (Technology*)TechHandle;
        
        if (tech && N>=0 && N<tech->parents_number)
        {
          Return((LLong)tech->parents[N].parent);
        }
        else
        {
          Return(0);
        }

        #undef TechHandle
        #undef N
        break;
      }
    case UFTechGetParentPointsNeeded_:
      {
        #define TechHandle P(0)
        #define N P(1)

        Technology *tech = (Technology*)TechHandle;
        
        if (tech && N>=0 && N<tech->parents_number)
        {
          Return((LLong)tech->parents[N].need_value);
        }
        else
        {
          Return(0);
        }

        #undef TechHandle
        #undef N
        break;
      }
    case UFTechSetParentPointsNeeded_:
      {
        #define TechHandle P(0)
        #define N P(1)
        #define NewValue P(2)

        Technology *tech = (Technology*)TechHandle;
        
        if (tech && N>=0 && N<tech->parents_number)
        {
          tech->parents[N].need_value = NewValue;
        }

        #undef TechHandle
        #undef N
        #undef NewValue
        break;
      }
    case UFGrantTechnology_:
      {
        #define Race P(0)
        #define TechName PS(1)

        GrantTechnology(Race, TechName);

        #undef Race
        #undef TechName
        break;
      }
    case UFAdvanceTechnology_:
      {
        #define Race P(0)
        #define TechName PS(1)
        #define Points P(2)

        AdvanceTechnology(Race, TechName, Points);

        #undef Race
        #undef TechName
        #undef Points
        break;
      }
    case UFGetTechPointsForResearchPoints_:
      {
        #define TechName PS(0)
        #define ResearchType P(1)
        #define ResearchPoints P(2)

        Technology *NewTech = Find_Technology((const char*)TechName);

        int Num = 0;

        if (NewTech)
        {
          for (int i = 0; i<NewTech->resourceReqCount; i++)
          {
            if (NewTech->resourceReqType[i]==ResearchType)
            {
              Num = round_float(NewTech->resourceReq[i]*(float)ResearchPoints);
              break;
            }
          }
        }

        Return(Num);

        #undef TechName
        #undef ResearchType
        #undef ResearchPoints
        break;
      }
    case UFGetTechPointsForResearchPointsHandle_:
      {
        #define TechHandle P(0)
        #define ResearchType P(1)
        #define ResearchPoints P(2)

        Technology *NewTech = (Technology*)TechHandle;

        int Num = 0;

        if (NewTech)
        {
          for (int i = 0; i<NewTech->resourceReqCount; i++)
          {
            if (NewTech->resourceReqType[i]==ResearchType)
            {
              Num = round_float(NewTech->resourceReq[i]*(float)ResearchPoints);
              break;
            }
          }
        }

        Return(Num);

        #undef TechHandle
        #undef ResearchType
        #undef ResearchPoints
        break;
      }
    case UFGetResearchPointsForTechPoints_:
      {
        #define TechName PS(0)
        #define TechPoints P(1)
        #define ResearchType P(2)

        Technology *NewTech = Find_Technology((const char*)TechName);

        int Num = 0;

        if (NewTech)
        {
          for (int i = 0; i<NewTech->resourceReqCount; i++)
          {
            if (NewTech->resourceReqType[i]==ResearchType && NewTech->resourceReq[i]>0.0f)
            {
              Num = round_float((float)TechPoints/NewTech->resourceReq[i]);
              break;
            }
          }
        }

        Return(Num);

        #undef TechName
        #undef TechPoints
        #undef ResearchType
        break;
      }
    case UFGetResearchPointsForTechPointsHandle_:
      {
        #define TechHandle P(0)
        #define TechPoints P(1)
        #define ResearchType P(2)

        Technology *NewTech = (Technology*)TechHandle;

        int Num = 0;

        if (NewTech)
        {
          for (int i = 0; i<NewTech->resourceReqCount; i++)
          {
            if (NewTech->resourceReqType[i]==ResearchType && NewTech->resourceReq[i]>0.0f)
            {
              Num = round_float((float)TechPoints/NewTech->resourceReq[i]);
              break;
            }
          }
        }

        Return(Num);

        #undef TechHandle
        #undef TechPoints
        #undef ResearchType
        break;
      }
    case UFResetTechnology_:
      {
        #define WRace P(0)

        Technology::resetOneRace(WRace);

        #undef WRace
        break;
      }
    case UFEnumerateAllStars_:
      {
        #define RaceID P(0)

        // pass E1_UNDEFINED as owner to get all Stars!
        Star *ThisStar = Star::All;
        
        int OwnerInt = RaceID;
        
        while (ThisStar)
        {
          if (OwnerInt==E1_UNDEFINED || GetBit(ThisStar->ClearPlanetOwners, OwnerInt))
          {
            E1PCallParm Parms(fEventParmInt, (LLong)(ThisStar));
            E1PThrowEvent("enumerate callback", &Parms);
          }
          
          ThisStar = ThisStar->Next;
        }


        #undef RaceID
        break;
      }
    case UFEnumerateInnerSpaceStars_:
      {
        #define RaceID P(0)

        Star *ThisStar = Star::All;
        
        int OwnerInt = RaceID;

        if (Star::NeedToRecalculateOwnershipForColonization)
          Star::CalculateOwnersForColonization();

        while (ThisStar)
        {
          if (ThisStar->CalculatedOwnerForColonization==OwnerInt)
          {
            E1PCallParm Parms(fEventParmInt, (LLong)(ThisStar));
            E1PThrowEvent("enumerate callback", &Parms);
          }
          
          ThisStar = ThisStar->Next;
        }

        #undef RaceID
        break;
      }
    case UFEnumerateStarNeighbours_:
      {
        #define StarHandle P(0)

        Star *ThisStar = (Star*)StarHandle;
        
        ForEachConnection(Conn, ThisStar)
        {
          const Star* To = Conn->To;

          E1PCallParm Parms(fEventParmInt, (LLong)(To));
          E1PThrowEvent("enumerate callback", &Parms);
        }

        #undef StarHandle
        break;
      }
    case UFEnumerateAllPlanets_:
      {
        #define RaceID P(0)

        // pass E1_UNDEFINED as owner to get all ECO Planets!

        Star *ThisStar = Star::All;
        
        int OwnerInt = RaceID;
        int Num = 0;
        
        while (ThisStar)
        {
          for (int i = 0; i<ThisStar->NumPlanets; i++)
          {
            if (OwnerInt==E1_UNDEFINED || ThisStar->Planets[i].Owner == OwnerInt)
            {
              E1PCallParm Parms(fEventParmInt, (LLong)(&ThisStar->Planets[i]));
              E1PThrowEvent("enumerate callback", &Parms);
            }
            
            Num++;
          }
          
          ThisStar = ThisStar->Next;
        }


        #undef RaceID
        break;
      }
    case UFEnumerateAllFleets_:
      {
        #define RaceID P(0)

        // pass E1_UNDEFINED as owner to get all Fleets!
        Fleet *ThisFleet = Fleet::All;
        
        int OwnerInt = RaceID;
        
        while (ThisFleet)
        {
          if (ThisFleet->Owner<Race::Number && RaceInfo[ThisFleet->Owner].PresentInGame)
          {
            if (OwnerInt==E1_UNDEFINED || ThisFleet->Owner==OwnerInt)
            {
              E1PCallParm Parms(fEventParmInt, (LLong)(ThisFleet));
              E1PThrowEvent("enumerate callback", &Parms);
            }
          }
          
          ThisFleet = ThisFleet->Next;
        }


        #undef RaceID
        break;
      }
    case UFEnumerateFleetsAtStar_:
      {
        #define Handle P(0)
        #define RaceID P(1)
        #define IncludeHidden P(2)

        // pass E1_UNDEFINED as owner to get all Fleets!
        Fleet *ThisFleet = ((Star*)Handle)->OrbitingFleets.Root;
        bool ThisHidden = (Yes_!=IncludeHidden);

        if (!ThisFleet && !ThisHidden)
        {
          ThisHidden = true;
          ThisFleet = ((Star*)Handle)->HiddenOrbitingFleets.Root;
        }

        int OwnerInt = RaceID;

        while (ThisFleet)
        {
          if (ThisFleet->Owner<Race::Number /*&& RaceInfo[ThisFleet->Owner].PresentInGame*/)
          {
            if (OwnerInt==E1_UNDEFINED || ThisFleet->Owner==OwnerInt)
            {
              E1PCallParm Parms(fEventParmInt, (LLong)(ThisFleet));
              E1PThrowEvent("enumerate callback", &Parms);
            }
          }
          
          ThisFleet = ThisFleet->NextInList;
          if (!ThisFleet && !ThisHidden)
          {
            ThisHidden = true;
            ThisFleet = ((Star*)Handle)->HiddenOrbitingFleets.Root;
          }
        }


        #undef Handle
        #undef RaceID
        #undef IncludeHidden
        break;
      }
    case UFEnumerateFleetsApproachingStar_:
      {
        #define StarHandle P(0)
        #define RaceID P(1)

        // pass E1_UNDEFINED as owner to get all Fleets!
        
        Star *ThisStar = (Star*)StarHandle;
        int OwnerInt = RaceID;

        ForEachFleet(Fl)
        {
          if (OwnerInt==E1_UNDEFINED || Fl->Owner==OwnerInt)
          {
            if (Fl->IsMoving() && Fl->Way->star==ThisStar)
            {
              E1PCallParm Parms(fEventParmInt, (LLong)(Fl));
              E1PThrowEvent("enumerate callback", &Parms);
            }
          }
        }

        #undef StarHandle
        #undef RaceID
        break;
      }
    case UFEnumerateShipsOfFleet_:
      {
        #define Handle P(0)
        #define CountInner P(1)


        Fleet *ThisFleet = (Fleet*)Handle;
        
        SpaceShip *S = ThisFleet->Ships;
        int _CI = CountInner;

        while (S!=NULL)
        {
          E1PCallParm Parms(fEventParmInt, (LLong)(S));
          E1PThrowEvent("enumerate callback", &Parms);
          
          if (Yes_==_CI)
          {
            SpaceShip *Inner = S->inner;
            
            while (Inner!=NULL)
            {
              E1PCallParm Parms(fEventParmInt, (LLong)(Inner));
              E1PThrowEvent("enumerate callback", &Parms);
              Inner = Inner->Next;
            }
          }
          
          S = S->Next;
        }

        #undef Handle
        #undef CountInner
        break;
      }
    case UFEnumerateShipList_:
      {
        #define Handle P(0)
        #define CountInner P(1)


        ShipList *S = (ShipList*)Handle;
        int _CI = CountInner;

        while (S!=NULL)
        {
          if (S->ShipRef)
          {
            E1PCallParm Parms(fEventParmInt, (LLong)(S->ShipRef));
            E1PThrowEvent("enumerate callback", &Parms);
            
            if (Yes_==_CI)
            {
              SpaceShip *Inner = S->ShipRef->inner;
              
              while (Inner!=NULL)
              {
                E1PCallParm Parms(fEventParmInt, (LLong)(Inner));
                E1PThrowEvent("enumerate callback", &Parms);
                Inner = Inner->Next;
              }
            }
          }
          
          S = S->Next;
        }

        #undef Handle
        #undef CountInner
        break;
      }
    case UFEnumerateDesignList_:
      {
        #define Handle P(0)

        DesignList *S = (DesignList*)Handle;
        
        while (S!=NULL)
        {
          if (S->DesignRef)
          {
            E1PCallParm Parms(fEventParmInt, (LLong)(S->DesignRef));
            E1PThrowEvent("enumerate callback", &Parms);
          }
          
          S = S->Next;
        }

        #undef Handle
        break;
      }
    case UFEnumerateDesigns_:
      {
        #define RaceID P(0)
        #define BodyType P(1)
        #define AllowAIDesigns P(2)
        #define AllowDeletedDesigns P(3)

        // pass -1 as BodyType to get all designs!
        // pass -1 as RaceID to get all races designs.
        int BodyTypeInt = BodyType;
        
        bool AllowDeleted = (Yes_==AllowDeletedDesigns);
        bool AllowAI = (Yes_==AllowAIDesigns);

        for (int i=0; i<totalDesigns; i++)
        {
          if (allDesigns[i]->power_balance>=0 && !allDesigns[i]->NotVisibleInDesigner() && (AllowDeleted || !allDesigns[i]->IsDeleted) && (AllowAI || !allDesigns[i]->isAI()))
          {
            if (RaceID==-1 || allDesigns[i]->Get_Body()->GoodForRace(RaceID))
            {
              if (BodyTypeInt==-1 || BodyTypeInt==allDesigns[i]->ship_body->Get_Type()->typeNo)
              {
                E1PCallParm Parms(fEventParmInt, (LLong)(allDesigns [i]));
                E1PThrowEvent("enumerate callback", &Parms);
              }
            }
          }
        }

        #undef RaceID
        #undef BodyType
        #undef AllowAIDesigns
        #undef AllowDeletedDesigns
        break;
      }
    case UFEnumerateAllTechnologies_:
      {
        #define WRace P(0)
        #define Applied P(1)
        #define Final P(2)

        // pass -1 as WRace to get all technologies!
        int CheckRace = WRace;
        
        ListIter iter (all_tech);
        Technology *ct;

        bool ListApplied = (Yes_==Applied);
        bool ListFinal = (Yes_==Final);
        
        while ((ct = (Technology*) ++iter))
        {
          if (CheckRace==-1 || ct->Is_Available(CheckRace))
          {
            if (ct!=BLOCKER && !ct->Hidden)
            {
              if ((ct->FinalTechnology && ListFinal) || (ListApplied && !ct->FinalTechnology))
              {
                E1PCallParm Parms(sfEventParmStr, ct->_name);
                E1PThrowEvent("enumerate callback", &Parms);
              }
            }
          }
        }

        #undef WRace
        #undef Applied
        #undef Final
        break;
      }
    case UFEnumerateAllTechnologiesHandles_:
      {
        #define WRace P(0)
        #define Applied P(1)
        #define Final P(2)

        // pass -1 as WRace to get all technologies!
        int CheckRace = WRace;
        
        ListIter iter (all_tech);
        Technology *ct;

        bool ListApplied = (Yes_==Applied);
        bool ListFinal = (Yes_==Final);
        
        while ((ct = (Technology*) ++iter))
        {
          if (CheckRace==-1 || ct->Is_Available(CheckRace))
          {
            if (ct!=BLOCKER && !ct->Hidden)
            {
              if ((ct->FinalTechnology && ListFinal) || (ListApplied && !ct->FinalTechnology))
              {
                E1PCallParm Parms(fEventParmInt, (LLong)ct);
                E1PThrowEvent("enumerate callback", &Parms);
              }
            }
          }
        }

        #undef WRace
        #undef Applied
        #undef Final
        break;
      }
    case UFEnumerateBorderStars_:
      {
        #define OfRace P(0)
        #define BorderWithRace P(1)
        #define CheckVisitedForRace P(2)


        int Count = EnumerateBorderStarsFunc(Bit(OfRace), BorderWithRace, CheckVisitedForRace);

        Return(Count)

        #undef OfRace
        #undef BorderWithRace
        #undef CheckVisitedForRace
        break;
      }
    case UFEnumerateAllTradeArgeements_:
      {
        #define _Race1 P(0)
        #define _Race2 P(1)

        int Race1 = _Race1;
        int Race2 = _Race2;

        for (TradeAgreementStruct *TA = GetRaceInfo(Race1).TradeAgreements; TA; TA = TA->Next)
        {
          if (TA->WithRace==Race2)
          {
            E1PCallParm Parms(fEventParmInt, (LLong)TA);
            E1PThrowEvent("enumerate callback", &Parms);
          }
        }

        for (TradeAgreementStruct *TA = GetRaceInfo(Race2).TradeAgreements; TA; TA = TA->Next)
        {
          if (TA->WithRace==Race1)
          {
            E1PCallParm Parms(fEventParmInt, (LLong)TA);
            E1PThrowEvent("enumerate callback", &Parms);
          }
        }


        #undef _Race1
        #undef _Race2
        break;
      }
    case UFEnumerateBatShips_:
      {
        #define FirstSide P(0)


        int Count = EnumerateBatShipsFunc(Yes_==FirstSide);

        Return(Count)

        #undef FirstSide
        break;
      }
    case UFEnumerateBatSelectedShips_:
      {


        int Count = EnumerateSelectedShipsFunc();

        Return(Count)

        break;
      }
    case UFGetECOPlanetResAmount_:
      {
        #define Handle P(0)
        #define ResType P(1)
        #define Mult P(2)

        Planet *ThisPlanet = (Planet*)Handle;
        int Result = ThisPlanet->GetResAmount(ResType)*Mult;
        
        Return(Result);

        #undef Handle
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetECOPlanetResBonus_:
      {
        #define Handle P(0)
        #define ResType P(1)
        #define Mult P(2)

        Planet *ThisPlanet = (Planet*)Handle;
        float Result = ThisPlanet->GetResBonus(ResType)*(float)Mult;
        
        Return(Result);

        #undef Handle
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetResCountForRace_:
      {
        #define Race P(0)
        #define ResType P(1)
        #define Mult P(2)

        float fResult = GetMineralAmount(Race, ResType);
        float fMult = Mult;
        fResult*=fMult;
        
        int Result = fResult;
        
        Return(Result);

        #undef Race
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetMaxResCountForRace_:
      {
        #define Race P(0)
        #define ResType P(1)
        #define Mult P(2)

        float fResult = GetMaxMineralAmount(Race, ResType);
        float fMult = Mult;
        fResult*=fMult;
        
        int Result = fResult;
        
        Return(Result);

        #undef Race
        #undef ResType
        #undef Mult
        break;
      }
    case UFMineralPurchasedThisYear_:
      {
        #define Race P(0)
        #define ResType P(1)

        if (GetBit(RaceStatus::MineralPurchasedThisYear[ResType], Race))
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef Race
        #undef ResType
        break;
      }
    case UFSetMineralPurchasedThisYear_:
      {
        #define Race P(0)
        #define ResType P(1)

        SetBit(RaceStatus::MineralPurchasedThisYear[ResType], Race);

        #undef Race
        #undef ResType
        break;
      }
    case UFAddResForRace_:
      {
        #define Race P(0)
        #define ResType P(1)
        #define Amount P(2)
        #define Mult P(3)

        float fAmount = Amount;
        float fMult = Mult;

        if (fMult>0)
          fAmount/=fMult;

        ECOAddResources(Race, ResType, fAmount);

        #undef Race
        #undef ResType
        #undef Amount
        #undef Mult
        break;
      }
    case UFDecResForRace_:
      {
        #define Race P(0)
        #define ResType P(1)
        #define Amount P(2)
        #define Mult P(3)

        float fAmount = Amount;
        float fMult = Mult;

        if (fMult>0)
          fAmount/=fMult;

        // return the amount of resource we were not able to collect
        int Result = fMult*ECODecResources(Race, ResType, fAmount);

        Return(Result);

        #undef Race
        #undef ResType
        #undef Amount
        #undef Mult
        break;
      }
    case UFGetResProduction_:
      {
        #define Race P(0)
        #define ResType P(1)
        #define Mult P(2)

        float fResult = GetRaceInfo(Race).GetProduction(ResType);
        float fMult = Mult;
        fResult*=fMult;
        
        int Result = fResult;
        
        Return(Result);

        #undef Race
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetResPrice_:
      {
        #define Race P(0)
        #define ResTypeSrc P(1)
        #define ResAmountSrc P(2)
        #define Mult P(3)
        #define ResTypeDst P(4)

        float fMult = Mult;
        float fAmount = ResAmountSrc;
        
        fAmount/=fMult;

        float fResult = GetRaceInfo(Race).Convert(ResTypeSrc, fAmount, ResTypeDst);
        fResult*=fMult;
        
        int Result = fResult;
        
        Return(Result);

        #undef Race
        #undef ResTypeSrc
        #undef ResAmountSrc
        #undef Mult
        #undef ResTypeDst
        break;
      }
    case UFAddTradeAgreement_:
      {
        #define Race1 P(0)
        #define Race2 P(1)
        #define GetRes P(2)
        #define GetAmount P(3)
        #define GiveRes P(4)
        #define GiveAmount P(5)
        #define Mult P(6)

        float fMult = Mult;
        float fGetAmount = GetAmount;
        float fGiveAmount = GiveAmount;
        
        fGetAmount/=fMult;
        fGiveAmount/=fMult;
        
        GetRaceInfo(Race1).AddTradeAgreement(Race2, GetRes, fGetAmount, GiveRes, fGiveAmount);

        #undef Race1
        #undef Race2
        #undef GetRes
        #undef GetAmount
        #undef GiveRes
        #undef GiveAmount
        #undef Mult
        break;
      }
    case UFContractForResourceExists_:
      {
        #define Race1 P(0)
        #define ResType P(1)

        if (GetRaceInfo(Race1).HasTradeAgreement(PlayerRace, ResType) || RaceInfo[PlayerRace].HasTradeAgreement(Race1, ResType))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef Race1
        #undef ResType
        break;
      }
    case UFCancelTradeAgreement_:
      {
        #define Race1 P(0)
        #define Race2 P(1)
        #define TAHandle P(2)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;

        GetRaceInfo(Race1).CancelTradeAgreement(TA);
        GetRaceInfo(Race2).CancelTradeAgreement(TA);

        #undef Race1
        #undef Race2
        #undef TAHandle
        break;
      }
    case UFTradeAgreementWithWhom_:
      {
        #define TAHandle P(0)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;
        
        Return(TA->WithRace)

        #undef TAHandle
        break;
      }
    case UFTradeAgreementGetRes_:
      {
        #define TAHandle P(0)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;
        
        Return(TA->GetRes)

        #undef TAHandle
        break;
      }
    case UFTradeAgreementGetAmount_:
      {
        #define TAHandle P(0)
        #define Mult P(1)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;
        
        LLong Ret = TA->GetAmount*Mult;

        Return(Ret)

        #undef TAHandle
        #undef Mult
        break;
      }
    case UFTradeAgreementGiveRes_:
      {
        #define TAHandle P(0)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;
        
        Return(TA->GiveRes)

        #undef TAHandle
        break;
      }
    case UFTradeAgreementGiveAmount_:
      {
        #define TAHandle P(0)
        #define Mult P(1)

        TradeAgreementStruct *TA = (TradeAgreementStruct*)TAHandle;
        
        LLong Ret = TA->GiveAmount*Mult;

        Return(Ret)

        #undef TAHandle
        #undef Mult
        break;
      }
    case UFSetMaxColonyModuleCapacity_:
      {
        #define Value P(0)

        MAX_COLONIST_AMOUNT = Value;

        #undef Value
        break;
      }
    case UFGetPlanetByID_:
      {
        #define PlanetID P(0)

    Return((LLong)Planet::GetByID(PlanetID))

        #undef PlanetID
        break;
      }
    case UFGetPlanetID_:
      {
        #define PlanetHandle P(0)

    Planet *Pl = (Planet*)PlanetHandle;
    Return((LLong)Pl->ID)

        #undef PlanetHandle
        break;
      }
    case UFGetPlanetType_:
      {
        #define PlanetHandle P(0)

    Planet *Pl = (Planet*)PlanetHandle;
    Return((LLong)Pl->_Type)

        #undef PlanetHandle
        break;
      }
    case UFSearchPlanetType_:
      {
        #define TypeName PS(0)

    Return((LLong)PlanetType::Find((const char*)TypeName));

        #undef TypeName
        break;
      }
    case UFChangePlanetOwner_:
      {
        #define PlanetHandle P(0)
        #define RaceID P(1)
        #define Amount P(2)
        #define Invade P(3)


        Planet *ThisPlanet = (Planet*)PlanetHandle;
        
        int Num = 0;
        for (; Num<ThisPlanet->Mother->NumPlanets && ThisPlanet!=&ThisPlanet->Mother->Planets[Num]; Num++);


        if (Num>=0 && Num<ThisPlanet->Mother->NumPlanets)
          ThisPlanet->Mother->InvadeColony(Num, RaceID, Amount, Yes_==Invade);

//        ChangeECOPlanetOwner(ThisPlanet, RaceID, Amount, Invade);

        #undef PlanetHandle
        #undef RaceID
        #undef Amount
        #undef Invade
        break;
      }
    case UFChangePlanetOwnerFake_:
      {
        #define PlanetHandle P(0)
        #define NewRaceID P(1)

        Planet *ThisPlanet = (Planet*)PlanetHandle;
        
        ThisPlanet->BackupRaceInfo();

        ThisPlanet->Owner = NewRaceID;

        for (PopulationStruct *Pop = ThisPlanet->AdditionalPopulation; Pop; Pop = Pop->Next)
          Pop->RaceID = NewRaceID;

        ThisPlanet->Mother->UpdatePlanetOwners();

        #undef PlanetHandle
        #undef NewRaceID
        break;
      }
    case UFGetPlanetOwner_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;

        Return(ThisPlanet->Owner)

        #undef Handle
        break;
      }
    case UFDestroyPlanet_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;

        Return( ThisPlanet->Destroy(false) ? Yes_ : No_ )

        #undef Handle
        break;
      }
    case UFMakePlanetDestruction_:
      {
        #define PlanetHandle P(0)
        #define PercentDestruction P(1)
        #define PercentMilitaryDestruction P(2)
        #define PercentPopulationKill P(3)
        #define KeepColonialModuleAndSpaceport P(4)


        Planet *ThisPlanet = (Planet *)PlanetHandle;
  
        ThisPlanet->MakeDestruction(0.01f*(float)PercentDestruction, 0.01f*(float)PercentMilitaryDestruction, 0.01f*PercentPopulationKill, Yes_==KeepColonialModuleAndSpaceport);

        #undef PlanetHandle
        #undef PercentDestruction
        #undef PercentMilitaryDestruction
        #undef PercentPopulationKill
        #undef KeepColonialModuleAndSpaceport
        break;
      }
    case UFGetECOPlanetBuildingAllowed_:
      {
        #define PlanetHandle P(0)
        #define BldType P(1)

        Planet *ThisPlanet = (Planet *)PlanetHandle;
        
        if (ThisPlanet->BuildingAllowed[BldType])
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef PlanetHandle
        #undef BldType
        break;
      }
    case UFGetECOPlanetMaxBuildingCount_:
      {
        #define Handle P(0)
        #define BldType P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(ThisPlanet->MaxBldCountPl[BldType])

        #undef Handle
        #undef BldType
        break;
      }
    case UFSetECOPlanetMaxBuildingCount_:
      {
        #define Handle P(0)
        #define BldType P(1)
        #define Count P(2)

        Planet *ThisPlanet = (Planet *)Handle;
        ThisPlanet->MaxBldCountPl[BldType] = Count;

        #undef Handle
        #undef BldType
        #undef Count
        break;
      }
    case UFGetECOPlanetBuildingCount_:
      {
        #define Handle P(0)
        #define BldType P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(ThisPlanet->BuildingsPresent[BldType])

        #undef Handle
        #undef BldType
        break;
      }
    case UFSetECOPlanetBuildingCount_:
      {
        #define Handle P(0)
        #define BldType P(1)
        #define Amount P(2)

        Planet *ThisPlanet = (Planet *)Handle;
        ThisPlanet->BuildingsPresent[BldType] = Amount;

        #undef Handle
        #undef BldType
        #undef Amount
        break;
      }
    case UFSetPlanetPopulation_:
      {
        #define Handle P(0)
        #define Amount P(1)

        Planet *ThisPlanet = (Planet *)Handle;

        int NewBase = Amount - (ThisPlanet->GetPopulation() - ThisPlanet->BasePopulation);
        
        ThisPlanet->BasePopulation = NewBase;
        
        if (ThisPlanet->BasePopulation<0)
          ThisPlanet->BasePopulation = 0;

        #undef Handle
        #undef Amount
        break;
      }
    case UFGetTotalPlanetPopulation_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(ThisPlanet->GetPopulation())

        #undef Handle
        break;
      }
    case UFGetPlanetPopulation_:
      {
        #define Handle P(0)
        #define RaceID P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(ThisPlanet->GetPopulation(RaceID))

        #undef Handle
        #undef RaceID
        break;
      }
    case UFGetPlanetAIValue_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(100.0f*ThisPlanet->PlanetAIValue)

        #undef Handle
        break;
      }
    case UFGetPlanetAIValueIndustry_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(100.0f*ThisPlanet->PlanetValueIndustry)

        #undef Handle
        break;
      }
    case UFGetPlanetAIValueMining_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(100.0f*ThisPlanet->PlanetValueMining)

        #undef Handle
        break;
      }
    case UFGetPlanetAIValueScience_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        Return(100.0f*ThisPlanet->PlanetValueScience)

        #undef Handle
        break;
      }
    case UFSetPlanetResource_:
      {
        #define Handle P(0)
        #define ResType P(1)
        #define Amount P(2)

        Planet *ThisPlanet = (Planet *)Handle;
        ThisPlanet->FreePlanetRes[ResType] = Amount;

        #undef Handle
        #undef ResType
        #undef Amount
        break;
      }
    case UFGetPlanetResource_:
      {
        #define Handle P(0)
        #define ResType P(1)
        #define Amount P(2)

        Planet *ThisPlanet = (Planet *)Handle;
        Return((int)ThisPlanet->FreePlanetRes[ResType]);

        #undef Handle
        #undef ResType
        #undef Amount
        break;
      }
    case UFSetPlanetAutomation_:
      {
        #define Handle P(0)
        #define Mode P(1)
        #define EraseOldModeBuilding P(2)

        Planet *ThisPlanet = (Planet *)Handle;
        ThisPlanet->SetAutoMode((Planet::AutoModeEnum)Mode, EraseOldModeBuilding==Yes_, EraseOldModeBuilding==Yes_);

        #undef Handle
        #undef Mode
        #undef EraseOldModeBuilding
        break;
      }
    case UFSetPlanetAutomationDirect_:
      {
        #define Handle P(0)
        #define Mode P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        ThisPlanet->AutoMode = (Planet::AutoModeEnum)Mode;

        #undef Handle
        #undef Mode
        break;
      }
    case UFGetPlanetName_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;

//          int PlanetIndex = 0;
//          
//          for (; PlanetIndex<ThisPlanet->Mother->NumPlanets; PlanetIndex++)
//            if (ThisPlanet == &ThisPlanet->Mother->Planets[PlanetIndex])
//              break;
//
//          char Result[256];
//          sprintf(Result, "%s-%s", ThisPlanet->Mother->Name, RomeNum[PlanetIndex]);

          Return((const char*)ThisPlanet->Name);

        #undef Handle
        break;
      }
    case UFSetPlanetName_:
      {
        #define Handle P(0)
        #define PName PS(1)

        Planet *ThisPlanet = (Planet *)Handle;
        
        ThisPlanet->Name = (const char*)PName;

        #undef Handle
        #undef PName
        break;
      }
    case UFGetPlanetValue_:
      {
        #define Handle P(0)
        #define WRace P(1)

        Planet *ThisPlanet = (Planet *)Handle;

        Return((LLong)ThisPlanet->GetCurrentValueForColonization(WRace, NULL));

        #undef Handle
        #undef WRace
        break;
      }
    case UFGetPlanetStar_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;

        Return((LLong)ThisPlanet->Mother);

        #undef Handle
        break;
      }
    case UFGetPlanetStarName_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;

          const char *Result = (const char*)ThisPlanet->Mother->descr_name;
          
          Return(Result);

        #undef Handle
        break;
      }
    case UFMarkPlanetAsHomeworld_:
      {
        #define Handle P(0)
        #define WRace P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        
        ThisPlanet->HomeworldForRace = WRace;

        #undef Handle
        #undef WRace
        break;
      }
    case UFIsHomeworldForRace_:
      {
        #define Handle P(0)
        #define WRace P(1)

        Planet *ThisPlanet = (Planet *)Handle;
        
        if (ThisPlanet->HomeworldForRace == WRace)
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef Handle
        #undef WRace
        break;
      }
    case UFGetHomeworld_:
      {
        #define WRace P(0)

        Planet *Best = NULL;
        int MaxPopulation = 0;

        ForEachStar(S)
        {
          bool HomeworldFound = false;

          ForEachPlanet(S, Pl)
          {
            if (Pl->Owner==WRace)
            {
              int Population = Pl->GetPopulation();

              if (Population>0)
              {
                if (Pl->HomeworldForRace==WRace)
                {
                  Best = Pl;
                  HomeworldFound = true;
                  break;
                }
                else
                {
                  if (Population>MaxPopulation)
                  {
                    Best = Pl;
                    MaxPopulation = Population;
                  }
                }
              }
            }
          }
          
          if (HomeworldFound)
            break;
        }
        
        Return((LLong)Best);

        #undef WRace
        break;
      }
    case UFCompleteBuildPlanetFake_:
      {
        #define Handle P(0)

        Planet *ThisPlanet = (Planet *)Handle;
        
        ThisPlanet->SimulateCompleteBuild();

        #undef Handle
        break;
      }
    case UFGetBuildingFleetAStrX1000_:
      {
        #define PlanetHandle P(0)
        #define WRace P(1)

    Planet *ThisPlanet = (Planet*)PlanetHandle;

    float AStrTotal = 0.0f;
    float AStr;
    float DStr;

    for (ConstructionItem *Cur = ThisPlanet->BuildQueue; Cur; Cur = Cur->Next)
    {
      if (!Cur->IsBuilding && Cur->ThisShip)
      {
        DesignADStr(Cur->ThisShip->Type, AStr, DStr);
        AStrTotal+=AStr;
      }
    }

    int Result = 1000.0f*AStrTotal;
    Return(Result);

        #undef PlanetHandle
        #undef WRace
        break;
      }
    case UFGetBuildingFleetDStrX10_:
      {
        #define PlanetHandle P(0)
        #define WRace P(1)

    Planet *ThisPlanet = (Planet*)PlanetHandle;

    float DStrTotal = 0.0f;
    float AStr;
    float DStr;

    for (ConstructionItem *Cur = ThisPlanet->BuildQueue; Cur; Cur = Cur->Next)
    {
      if (!Cur->IsBuilding && Cur->ThisShip)
      {
        DesignADStr(Cur->ThisShip->Type, AStr, DStr);
        DStrTotal+=DStr;
      }
    }

    int Result = 10.0f*DStrTotal;
    Return(Result);

        #undef PlanetHandle
        #undef WRace
        break;
      }
    case UFGetPlannedFleetAStrX1000_:
      {
        #define PlanetHandle P(0)
        #define WRace P(1)

    Planet *ThisPlanet = (Planet*)PlanetHandle;

    float AStrTotal = 0.0f;
    float AStr;
    float DStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisFighter, AStr, DStr);
    AStrTotal+=AStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisDefender, AStr, DStr);
    AStrTotal+=AStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisCarrier, AStr, DStr);
    AStrTotal+=AStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisAttacker, AStr, DStr);
    AStrTotal+=AStr;

//    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisPeaceMaker, AStr, DStr);
//    AStrTotal+=AStr;

    int Result = 1000.0f*AStrTotal;
    Return(Result);

        #undef PlanetHandle
        #undef WRace
        break;
      }
    case UFGetPlannedFleetDStrX10_:
      {
        #define PlanetHandle P(0)
        #define WRace P(1)

    Planet *ThisPlanet = (Planet*)PlanetHandle;

    float DStrTotal = 0.0f;
    float AStr;
    float DStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisFighter, AStr, DStr);
    DStrTotal+=DStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisDefender, AStr, DStr);
    DStrTotal+=DStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisCarrier, AStr, DStr);
    DStrTotal+=DStr;

    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisAttacker, AStr, DStr);
    DStrTotal+=DStr;

//    GetPlannedShipsCountADStr(WRace, ThisPlanet->Mother, aisPeaceMaker, AStr, DStr);
//    DStrTotal+=DStr;

    int Result = 10.0f*DStrTotal;
    Return(Result);

        #undef PlanetHandle
        #undef WRace
        break;
      }
    case UFClearBuildQueue_:
      {
        #define PlanetHandle P(0)

    Planet *ThisPlanet = (Planet*)PlanetHandle;
    
    ThisPlanet->ClearBuildQueue();

        #undef PlanetHandle
        break;
      }
    case UFHasBuildQueue_:
      {
        #define PlanetHandle P(0)

    Planet *ThisPlanet = (Planet*)PlanetHandle;
    
    if (ThisPlanet->BuildQueue)
    {
      Return(Yes_)
    }
    else
    {
      Return(No_)
    }

        #undef PlanetHandle
        break;
      }
    case UFAddShipToBuildQueuePlayer_:
      {
        #define PlanetHandle P(0)
        #define ShipDesign P(1)

    Planet *ThisPlanet = (Planet*)PlanetHandle;
    Ship_Design *Design = (Ship_Design *)ShipDesign;
    
    ConstructionItem *ShBld = ThisPlanet->AddToQueue(new ConstructionItem(Design, adpMultipurpose, E1_UNDEFINED, PlayerRace));

        #undef PlanetHandle
        #undef ShipDesign
        break;
      }
    case UFAddShipToBuildQueue_:
      {
        #define PlanetHandle P(0)
        #define ShipDesign P(1)
        #define AIType P(2)
        #define AIRole P(3)
        #define Count P(4)
        #define NullMineralReq P(5)

    Planet *ThisPlanet = (Planet*)PlanetHandle;
    Ship_Design *Design = (Ship_Design *)ShipDesign;
    
    int CountI = Count;
    
    while (CountI>0)
    {
      ConstructionItem *ShBld = ThisPlanet->AddToQueue(new ConstructionItem(Design, AIRole, E1_UNDEFINED, ThisPlanet->Owner));

      if (ThisPlanet->Owner!=PlayerRace)
      {
        ShBld->ThisShip->AIInfo.ShipType = AIType;
        ShBld->ThisShip->AIInfo.ShipRole = AIRole;
        ShBld->ForceShip = true;
      }
      
      if (Yes_==NullMineralReq)
      {
        for (ConsumptionItemStruct *Cur = ShBld->ConsumptionItems; Cur; Cur = Cur->Next)
          if (AllRes[Cur->Type].RClass==rclassMineral)
            Cur->Value = 0.0f;
      }

      CountI--;
    }

        #undef PlanetHandle
        #undef ShipDesign
        #undef AIType
        #undef AIRole
        #undef Count
        #undef NullMineralReq
        break;
      }
    case UFPlanShipProduction_:
      {
        #define RaceID P(0)
        #define PlanetHandle P(1)
        #define DesignHandle P(2)
        #define AIType P(3)
        #define AIRole P(4)
        #define Order P(5)
        #define Count P(6)
        #define HighPriority P(7)

        Planet *ThisPlanet = (Planet*)PlanetHandle;
        
        Ship_Design *ThisDesign = (Ship_Design*)DesignHandle;
        
        int CountI = Count;
        
        while (CountI>0)
        {
          AIShipList *AIShip = new AIShipList(AIType, AIRole, RaceID, Order, ThisPlanet ? ThisPlanet->Mother : NULL);
          AIShip->Build = ThisDesign;
          AIShip->PriorityBuild = (Yes_==HighPriority);
          
          CountI--;
        }

        #undef RaceID
        #undef PlanetHandle
        #undef DesignHandle
        #undef AIType
        #undef AIRole
        #undef Order
        #undef Count
        #undef HighPriority
        break;
      }
    case UFShareInfoAboutClosestPlanet_:
      {
        #define OfRace P(0)
        #define KnownTo P(1)
        #define ClosestTo P(2)

        ShareInfoAboutClosestPlanet(OfRace, KnownTo, ClosestTo);

        #undef OfRace
        #undef KnownTo
        #undef ClosestTo
        break;
      }
    case UFGetFleetByID_:
      {
        #define FleetID P(0)

    Return((LLong)Fleet::GetByID(FleetID))

        #undef FleetID
        break;
      }
    case UFGetFleetID_:
      {
        #define FleetHandle P(0)

    Fleet *Fl = (Fleet*)FleetHandle;

    Return((LLong)Fl->ID)

        #undef FleetHandle
        break;
      }
    case UFFleetPresent_:
      {
        #define StarHandle P(0)
        #define RaceID P(1)
        #define CheckHidden P(2)

        // pass -1 as owner check if any fleet present!
        Fleet *ThisFleet = ((Star*)StarHandle)->OrbitingFleets.Root;
        bool ThisHidden = (Yes_!=CheckHidden);

        if (!ThisFleet && !ThisHidden)
        {
          ThisHidden = true;
          ThisFleet = ((Star*)StarHandle)->HiddenOrbitingFleets.Root;
        }

        int OwnerInt = RaceID;

        int Result = No_;
        
        while (ThisFleet)
        {
          if (ThisFleet->Owner<Race::Number && RaceInfo[ThisFleet->Owner].PresentInGame)
          {
            if (OwnerInt==-1 || ThisFleet->Owner==OwnerInt)
            {
              Result = Yes_;
              break;
            }
          }
          
          ThisFleet = ThisFleet->NextInList;
          
          if (!ThisFleet && !ThisHidden)
          {
            ThisHidden = true;
            ThisFleet = ((Star*)StarHandle)->HiddenOrbitingFleets.Root;
          }
        }
        
        Return(Result);

        #undef StarHandle
        #undef RaceID
        #undef CheckHidden
        break;
      }
    case UFGetFleetStrengthX100_:
      {
        #define FleetHandle P(0)

        Fleet *This = (Fleet*)FleetHandle;
        
        float AStr;
        float DStr;

        GetFleetADStr(This, AStr, DStr);
        
        int Result = 100.0f*AStr;
        
        Return(Result);

        #undef FleetHandle
        break;
      }
    case UFGetFleetAStrX1000_:
      {
        #define FleetHandle P(0)

        Fleet *This = (Fleet*)FleetHandle;
        
        float AStr;
        float DStr;

        GetFleetADStr(This, AStr, DStr);
        
        int Result = 1000.0f*AStr;
        
        Return(Result);

        #undef FleetHandle
        break;
      }
    case UFGetFleetDStrX10_:
      {
        #define FleetHandle P(0)

        Fleet *This = (Fleet*)FleetHandle;
        
        float AStr;
        float DStr;

        GetFleetADStr(This, AStr, DStr);
        
        int Result = 10.0f*DStr;
        
        Return(Result);

        #undef FleetHandle
        break;
      }
    case UFCalculateWinProb_:
      {
        #define FAStrx1000 P(0)
        #define FDStrx10 P(1)
        #define AAStrx1000 P(2)
        #define ADStrx10 P(3)

        int WinProb = CalculateWinProb((float)FAStrx1000 / 1000.0f, (float)FDStrx10 / 10.0f, (float)AAStrx1000 / 1000.0f, (float)ADStrx10 / 10.0f);

        Return(WinProb)

        #undef FAStrx1000
        #undef FDStrx10
        #undef AAStrx1000
        #undef ADStrx10
        break;
      }
    case UFIsContainer_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        if (ThisFleet->Containers && !ThisFleet->Ships)
        {
          Return(Yes_)
        }
        else
        {
          Return(No_);
        }

        #undef FleetHandle
        break;
      }
    case UFFleetGetSpecialContainer_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        if (ThisFleet->IsSpecialContainer())
        {
          Return((LLong)ThisFleet->Containers)
        }
        else
        {
          Return(0);
        }

        #undef FleetHandle
        break;
      }
    case UFGetFleetOwner_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return(ThisFleet->Owner);

        #undef FleetHandle
        break;
      }
    case UFNewFleet_:
      {
        #define Owner P(0)
        #define StarHandle P(1)
        #define ShipHandle P(2)

        Star *S = (Star*)StarHandle;
        SpaceShip *ThisShip = (SpaceShip*)ShipHandle;
        
        Fleet *Fl = MakeNewFleet(Owner, S);

        if (ThisShip)
          Fl->Add(ThisShip);
          
        Return((LLong)Fl)

        #undef Owner
        #undef StarHandle
        #undef ShipHandle
        break;
      }
    case UFKillFleet_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        ThisFleet->Kill();

        #undef FleetHandle
        break;
      }
    case UFSetFleetReporting_:
      {
        #define FleetHandle P(0)
        #define Option P(1)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        SetBit(ThisFleet->ReportToE1P, Option);

        #undef FleetHandle
        #undef Option
        break;
      }
    case UFClearFleetReporting_:
      {
        #define FleetHandle P(0)
        #define Option P(1)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        ClearBit(ThisFleet->ReportToE1P, Option);

        #undef FleetHandle
        #undef Option
        break;
      }
    case UFDeleteShipFromFleet_:
      {
        #define FleetHandle P(0)
        #define ShipHandle P(1)
        #define Destroy P(2)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        SpaceShip *ThisShip = (SpaceShip*)ShipHandle;
        
        ThisFleet->Del(ThisShip, true);
        
        if (Destroy==Yes_)
          delete ThisShip;

        #undef FleetHandle
        #undef ShipHandle
        #undef Destroy
        break;
      }
    case UFAddShipToFleet_:
      {
        #define FleetHandle P(0)
        #define ShipHandle P(1)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        SpaceShip *ThisShip = (SpaceShip*)ShipHandle;
        
        ThisFleet->Add(ThisShip);

        #undef FleetHandle
        #undef ShipHandle
        break;
      }
    case UFFleetPutFightersInHangars_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;

        LoadAllFightersToHangars(ThisFleet);

        #undef FleetHandle
        break;
      }
    case UFFleetDetachNonHyperShips_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;

        SplitLongRangeAndShortRange(ThisFleet);

        #undef FleetHandle
        break;
      }
    case UFMergeFleets_:
      {
        #define DestHandle P(0)
        #define SrcHandle P(1)

        Fleet *Dest = (Fleet*)DestHandle;
        Fleet *Src = (Fleet*)SrcHandle;

        Dest->Merge(Src);

        #undef DestHandle
        #undef SrcHandle
        break;
      }
    case UFGetFleetHome_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return((LLong)ThisFleet->Home);

        #undef FleetHandle
        break;
      }
    case UFGetFleetHomeName_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        const char *Result = (const char*)ThisFleet->Home->descr_name;
        
        Return(Result);

        #undef FleetHandle
        break;
      }
    case UFGetFleetDestination_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        if (ThisFleet->Way)
        {
          Return((LLong)ThisFleet->Way->star);
        }
        else
        {
          Return((LLong)ThisFleet->Home);
        }

        #undef FleetHandle
        break;
      }
    case UFGetFleetDestinationName_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        const char *Result;

        if (ThisFleet->Way)
        {
          Result = (const char*)ThisFleet->Way->star->descr_name;
        }
        else
        {
          Result = (const char*)ThisFleet->Home->descr_name;
        }

        Return(Result);

        #undef FleetHandle
        break;
      }
    case UFGetFleetDescentSpace_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return(ThisFleet->GetTotalDescentSpace();)

        #undef FleetHandle
        break;
      }
    case UFGetFleetUsedDescentSpace_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return(ThisFleet->GetUsedDescentSpace();)

        #undef FleetHandle
        break;
      }
    case UFGetFleetCargoSpace_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return(ThisFleet->GetTotalContainerSpace();)

        #undef FleetHandle
        break;
      }
    case UFGetFleetFreeCargoSpace_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        Return(ThisFleet->GetFreeContainerSpace();)

        #undef FleetHandle
        break;
      }
    case UFFleetIsMoving_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;

        if (ThisFleet->IsMoving())
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }

        #undef FleetHandle
        break;
      }
    case UFCancelFleetRoute_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        
        if (ThisFleet)
          ThisFleet->CancelRoute();

        #undef FleetHandle
        break;
      }
    case UFFleetGetMaxDist_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;

        Return((int)ThisFleet->MaxDist())

        #undef FleetHandle
        break;
      }
    case UFFleetGetMaxDistRefilled_:
      {
        #define FleetHandle P(0)

        Fleet *ThisFleet = (Fleet*)FleetHandle;

        Return((int)ThisFleet->MaxDistRefilled())

        #undef FleetHandle
        break;
      }
    case UFFleetTeleport_:
      {
        #define FleetHandle P(0)
        #define StarHandle P(1)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        Star *S = (Star*)StarHandle;

        ThisFleet->LeaveOrbit();
        ThisFleet->EnterOrbit(S);

        #undef FleetHandle
        #undef StarHandle
        break;
      }
    case UFPerformWormholeJump_:
      {
        #define FleetHandle P(0)
        #define StarHandle P(1)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        Star *S = (Star*)StarHandle;

//        ThisFleet->Home->WormholeEffect(false);
        ThisFleet->LeaveOrbit();
        ThisFleet->EnterOrbit(S);
//        S->WormholeEffect(true);
        Galaxy::ClearCenteredState();
        Galaxy::SelectStar(S, true);
        Galaxy::SelectFleet(ThisFleet, false);

        #undef FleetHandle
        #undef StarHandle
        break;
      }
    case UFFleetFlyTo_:
      {
        #define FleetHandle P(0)
        #define StarHandle P(1)
        #define IgnoreDistance P(2)
        #define UseSafe P(3)

        Fleet *ThisFleet = (Fleet*)FleetHandle;
        Star *S = (Star*)StarHandle;

        Trace("Fleet %lld\n", ThisFleet->ID);

        if (!ThisFleet->IsMoving() && ThisFleet->MaxDistRefilled()>0)
        {
          Trace("Not moving\n");
          int MaxDistance = INT_MAX;
          
          if (Yes_!=IgnoreDistance)
            MaxDistance = ThisFleet->MaxDist();

          Trace("MaxDist = %d\n", MaxDistance);

          if (MaxDistance>0)
          {
            Route *NewRoute = NULL;
            
            // check direct flight
            
            float MinDivider = ThisFleet->GetDirectFlightCoeff();
            
            if (MinDivider>0.0f)
            {
              NewRoute = new Route(S, NULL);
              NewRoute->Virtual = true;
              NewRoute = new Route(ThisFleet->Home, NewRoute);
              int CorrectedLength = round_float(GetDistance(NewRoute->star->Location, NewRoute->Next->star->Location)*Galaxy::starScaleFactor/MinDivider);
              
              if (CorrectedLength>MaxDistance)
              {
                NewRoute = DeleteAll(NewRoute);
              }
            }
            
            if (!NewRoute)
            {
              if (Yes_==UseSafe)
                NewRoute = BestRoute::FindSafe(ThisFleet->Home, S, ThisFleet->Owner, MaxDistance, ThisFleet->IsPeaceful() ? plPassNonMilitary_ : plPassMilitary_);
              else
                NewRoute = BestRoute::FindAny(ThisFleet->Home, S, ThisFleet->Owner, MaxDistance);
            }
            
            if (NewRoute)
            {
              Trace("Route found!\n");

              ThisFleet->Move(NewRoute, false);
              Return(Yes_);
            }
            else
            {
              Return(No_);
            }
          }
          else
          {
            Return(No_);
          }
        }
        else
        {
          Return(No_);
        }

        #undef FleetHandle
        #undef StarHandle
        #undef IgnoreDistance
        #undef UseSafe
        break;
      }
    case UFFleetGetClosestSafeStar_:
      {
        #define FleetHandle P(0)
        #define IgnoreThis P(1)

        Fleet *Fl = (Fleet*)FleetHandle;
        
        int WayLen;

        Star *Dest = GetClosestSafeStar(Fl->Home, Fl->Owner, WayLen, IgnoreThis==Yes_);
        ClearSortedStarMaps();

        Return((LLong)Dest)

        #undef FleetHandle
        #undef IgnoreThis
        break;
      }
    case UFFleetForceFlySafeStar_:
      {
        #define FleetHandle P(0)

        Fleet *Fl = (Fleet*)FleetHandle;

        if (ForceFlyToSafeStar(Fl, Fl->Owner))
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef FleetHandle
        break;
      }
    case UFFleetChangeOwner_:
      {
        #define FleetHandle P(0)
        #define WRace P(1)

        Fleet *Fl = (Fleet*)FleetHandle;

        Fl->Owner = WRace;
        
        for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
        {
          Sh->ChangeOwner(WRace);

          for (SpaceContainer *Cont = Sh->containers; Cont; Cont = Cont->Next)
          {
            Cont->Owner = WRace;
          }

          for (SpaceShip *Inn = Sh->inner; Inn; Inn = Inn->Next)
            Inn->ChangeOwner(WRace);
        }

        for (SpaceContainer *Cont = Fl->Containers; Cont; Cont = Cont->Next)
        {
          Cont->Owner = WRace;
        }

        #undef FleetHandle
        #undef WRace
        break;
      }
    case UFFleetChangeOwnerSmallShips_:
      {
        #define FleetHandle P(0)
        #define WRace P(1)

        Fleet *Fl = (Fleet*)FleetHandle;

        bool CanConvertWholeFleet = true;

        for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
        {
          if (Sh->IsCapital())
          {
            CanConvertWholeFleet = false;
            break;
          }
        }

        Fleet *SmallShipsFleet = NULL;

        if (CanConvertWholeFleet)
        {
          Fl->Owner = WRace;
          
          for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
            Sh->ChangeOwner(WRace);
        }
        else
        {
          SpaceShip *Sh = Fl->Ships;

          while (Sh)
          {
            SpaceShip *Next = Sh->Next;
            
            if (!Sh->IsCapital())
            {
              Fl->Del(Sh);
              Sh->ChangeOwner(WRace);
              
              if (!SmallShipsFleet)
              {
                ForEachOrbitingOrHiddenFleetVisibleTo(TmpFl, Fl->Home, WRace)
                {
                  if (TmpFl!=Fl)
                  {
                    bool SmallFleetFound = true;
                    for (SpaceShip *TmpSh = TmpFl->Ships; TmpSh; TmpSh = TmpSh->Next)
                    {
                      if (TmpSh->IsCapital())
                      {
                        SmallFleetFound = false;
                        break;
                      }
                    }
                    
                    if (SmallFleetFound)
                    {
                      SmallShipsFleet = TmpFl;
                      break;
                    }
                  }
                }
                
                if (!SmallShipsFleet)
                  SmallShipsFleet = MakeNewFleet(WRace, Fl->Home);
              }
              
              SmallShipsFleet->Add(Sh);
            }
            
            Sh = Next;
          }
          
        }

        #undef FleetHandle
        #undef WRace
        break;
      }
    case UFIsPeacefulFleet_:
      {
        #define FleetHandle P(0)

        Fleet *Fl = (Fleet*)FleetHandle;
        
        int Peaceful = Fl->IsPeaceful() ? Yes_ : No_;
                
        Return(Peaceful)

        #undef FleetHandle
        break;
      }
    case UFIsAttackFleet_:
      {
        #define FleetHandle P(0)

        Fleet *Fl = (Fleet*)FleetHandle;
        
        int Attack = No_;
        
        for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
        {
          if (Sh->AIIsAttackerExt() || Sh->AITypeIs(aisInvader) || Sh->AITypeIs(aisBomber))
          {
            Attack = Yes_;
            break;
          }
        }

        Return(Attack)

        #undef FleetHandle
        break;
      }
    case UFFleetAITypeIs_:
      {
        #define FleetHandle P(0)
        #define Type P(1)

        Fleet *Fl = (Fleet*)FleetHandle;

        if (Fl->AITypeIs(Type))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }


        #undef FleetHandle
        #undef Type
        break;
      }
    case UFFleetAIOrderIs_:
      {
        #define FleetHandle P(0)
        #define Order P(1)

        Fleet *Fl = (Fleet*)FleetHandle;

        if (Fl->AIOrderIs(Order))
        {
          Return(Yes_);
        }
        else
        {
          Return(No_);
        }


        #undef FleetHandle
        #undef Order
        break;
      }
    case UFMakeFleetNonGrata_:
      {
        #define FleetHandle P(0)
        #define RaceID P(1)

        Fleet *Fl = (Fleet*)FleetHandle;
        int RaceIDInt = RaceID;

        for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
        {
          SetBit(Sh->NonGrata, RaceIDInt);
        }

        #undef FleetHandle
        #undef RaceID
        break;
      }
    case UFGetSelectedFleet_:
      {

    LLong Handle = (LLong)Galaxy::SelectedFleet();
    
    Return (Handle)

        break;
      }
    case UFFleetVisibleOnMap_:
      {
        #define Handle P(0)

    Fleet *WFleet = (Fleet*)Handle;
    
    GCStar Obj;
    Obj.SetFleet(WFleet);

    Return (Galaxy::ObjectVisibleOnMap(Obj) ? Yes_ : No_)

        #undef Handle
        break;
      }
    case UFFleetSetNonGrataForPlayer_:
      {
        #define FleetHandle P(0)
        #define State P(1)

    Fleet *WFleet = (Fleet*)FleetHandle;

    for (SpaceShip *Sh = WFleet->Ships; Sh; Sh = Sh->Next)
      Sh->NonGrataForPlayer = State;

        #undef FleetHandle
        #undef State
        break;
      }
    case UFFleetGetNonGrataForPlayer_:
      {
        #define FleetHandle P(0)

    Fleet *WFleet = (Fleet*)FleetHandle;

    int Min = NonGrataNotWarned_;

    for (SpaceShip *Sh = WFleet->Ships; Sh; Sh = Sh->Next)
      if (Sh->NonGrataForPlayer>Min)
        Min = Sh->NonGrataForPlayer;

    Return(Min)

        #undef FleetHandle
        break;
      }
    case UFIsFleetInInnerSpace_:
      {
        #define FleetHandle P(0)
        #define RaceSpace P(1)

    Fleet *WFleet = (Fleet*)FleetHandle;

    Return( IsFleetInInnerSpace(WFleet, RaceSpace) ? Yes_ : No_)

        #undef FleetHandle
        #undef RaceSpace
        break;
      }
    case UFCreateShipList_:
      {

    LLong Handle = (LLong)new ShipList(NULL);
    
    Return (Handle)

        break;
      }
    case UFCreateDesignList_:
      {

    LLong Handle = (LLong)new DesignList(NULL);
    
    Return (Handle)

        break;
      }
    case UFAddShipToShipList_:
      {
        #define ShipListHandle P(0)
        #define ShipHandle P(1)

    ShipList *SL = (ShipList*)ShipListHandle;
    SpaceShip *Sh = (SpaceShip*)ShipHandle;

    if (SL && Sh)
    {
      if (!SL->ShipRef)
        SL->ShipRef = Sh;
      else
      {
        SL->Next = new ShipList(Sh, SL->Next);
      }
    }

        #undef ShipListHandle
        #undef ShipHandle
        break;
      }
    case UFAddFleetToShipList_:
      {
        #define ShipListHandle P(0)
        #define FleetHandle P(1)

    ShipList *SL = (ShipList*)ShipListHandle;
    Fleet *Fl = (Fleet*)FleetHandle;

    if (SL && Fl)
    {
      for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
      {
        if (!SL->ShipRef)
          SL->ShipRef = Sh;
        else
        {
          SL->Next = new ShipList(Sh, SL->Next);
        }
      }
    }

        #undef ShipListHandle
        #undef FleetHandle
        break;
      }
    case UFAddShipToDesignList_:
      {
        #define DesignListHandle P(0)
        #define ShipHandle P(1)

    DesignList *SL = (DesignList*)DesignListHandle;
    SpaceShip *Sh = (SpaceShip*)ShipHandle;

    if (SL && Sh)
    {
      if (!SL->DesignRef)
        SL->DesignRef = Sh->Type;
      else
      {
        SL->Next = new DesignList(Sh->Type, SL->Next);
      }
    }

        #undef DesignListHandle
        #undef ShipHandle
        break;
      }
    case UFGetDesignListSize_:
      {
        #define DesignListHandle P(0)

    DesignList *SL = (DesignList*)DesignListHandle;

    int Size = 0;

    for (;SL; SL = SL->Next)
      Size++;

    Return(Size)

        #undef DesignListHandle
        break;
      }
    case UFIsDesignInList_:
      {
        #define DesignListHandle P(0)
        #define ShipDesignHandle P(1)

    DesignList *SL = (DesignList*)DesignListHandle;

    LLong Present = No_;

    for (;SL; SL = SL->Next)
    {
      if (SL->DesignRef==(Ship_Design*)ShipDesignHandle)
      {
        Present = Yes_;
        break;
      }
    }

    Return(Present)

        #undef DesignListHandle
        #undef ShipDesignHandle
        break;
      }
    case UFGetDesignNumInList_:
      {
        #define DesignListHandle P(0)
        #define ShipDesignHandle P(1)

    DesignList *SL = (DesignList*)DesignListHandle;

    int Count = 0;

    for (;SL; SL = SL->Next)
    {
      if (SL->DesignRef==(Ship_Design*)ShipDesignHandle)
      {
        Count++;
      }
    }

    Return(Count)

        #undef DesignListHandle
        #undef ShipDesignHandle
        break;
      }
    case UFAddDesignToDesignList_:
      {
        #define DesignListHandle P(0)
        #define DesignHandle P(1)

    DesignList *SL = (DesignList*)DesignListHandle;
    Ship_Design *Sh = (Ship_Design*)DesignHandle;

    if (SL && Sh)
    {
      if (!SL->DesignRef)
        SL->DesignRef = Sh;
      else
      {
        SL->Next = new DesignList(Sh, SL->Next);
      }
    }

        #undef DesignListHandle
        #undef DesignHandle
        break;
      }
    case UFDeleteShipList_:
      {
        #define ShipListHandle P(0)

    ShipList *SL = (ShipList*)ShipListHandle;

    ClearListSTD(ShipList, SL)

        #undef ShipListHandle
        break;
      }
    case UFDeleteDesignList_:
      {
        #define DesignListHandle P(0)

    DesignList *SL = (DesignList*)DesignListHandle;

    ClearListSTD(DesignList, SL)

        #undef DesignListHandle
        break;
      }
    case UFCalculateWinProbShipListVSDesignList_:
      {
        #define ShipListHandle P(0)
        #define DesignListHandle P(1)

    ShipList *SL = (ShipList*)ShipListHandle;
    DesignList *DL = (DesignList *)DesignListHandle;

    AStrStruct *AStrFirst = NULL;
    DStrStruct *DStrFirst = NULL;
    AStrStruct *AStrSecond = NULL;
    DStrStruct *DStrSecond = NULL;

    for (; SL; SL = SL->Next)
    {
      if (SL->ShipRef)
        DesignADStrExistingDetailed(SL->ShipRef, AStrFirst, DStrFirst);
    }

    for (; DL; DL = DL->Next)
    {
      if (DL->DesignRef)
        DesignADStrDetailed(DL->DesignRef, AStrSecond, DStrSecond);
    }

    int WinProb = CalculateWinProbDetailed(AStrFirst, DStrFirst, AStrSecond, DStrSecond);

    ClearListSTD(AStrStruct, AStrFirst)
    ClearListSTD(AStrStruct, AStrSecond)
    ClearListSTD(DStrStruct, DStrFirst)
    ClearListSTD(DStrStruct, DStrSecond)

    Return(WinProb)

        #undef ShipListHandle
        #undef DesignListHandle
        break;
      }
    case UFCalculateWinProbShipListVSShipList_:
      {
        #define ShipListHandle P(0)
        #define ShipListHandle1 P(1)

    ShipList *SL = (ShipList*)ShipListHandle;
    ShipList *DL = (ShipList *)ShipListHandle1;

    AStrStruct *AStrFirst = NULL;
    DStrStruct *DStrFirst = NULL;
    AStrStruct *AStrSecond = NULL;
    DStrStruct *DStrSecond = NULL;

    for (; SL; SL = SL->Next)
    {
      if (SL->ShipRef)
        DesignADStrExistingDetailed(SL->ShipRef, AStrFirst, DStrFirst);
    }

    for (; DL; DL = DL->Next)
    {
      if (DL->ShipRef)
        DesignADStrExistingDetailed(DL->ShipRef, AStrSecond, DStrSecond);
    }

    int WinProb = CalculateWinProbDetailed(AStrFirst, DStrFirst, AStrSecond, DStrSecond);

    ClearListSTD(AStrStruct, AStrFirst)
    ClearListSTD(AStrStruct, AStrSecond)
    ClearListSTD(DStrStruct, DStrFirst)
    ClearListSTD(DStrStruct, DStrSecond)

    Return(WinProb)

        #undef ShipListHandle
        #undef ShipListHandle1
        break;
      }
    case UFCalculateWinProbDesignListVSDesignList_:
      {
        #define DesignListHandle P(0)
        #define DesignListHandle1 P(1)

    DesignList *SL = (DesignList*)DesignListHandle;
    DesignList *DL = (DesignList *)DesignListHandle1;

    AStrStruct *AStrFirst = NULL;
    DStrStruct *DStrFirst = NULL;
    AStrStruct *AStrSecond = NULL;
    DStrStruct *DStrSecond = NULL;

    for (; SL; SL = SL->Next)
    {
      if (SL->DesignRef)
        DesignADStrDetailed(SL->DesignRef, AStrFirst, DStrFirst);
    }

    for (; DL; DL = DL->Next)
    {
      if (DL->DesignRef)
        DesignADStrDetailed(DL->DesignRef, AStrSecond, DStrSecond);
    }

    int WinProb = CalculateWinProbDetailed(AStrFirst, DStrFirst, AStrSecond, DStrSecond);

    ClearListSTD(AStrStruct, AStrFirst)
    ClearListSTD(AStrStruct, AStrSecond)
    ClearListSTD(DStrStruct, DStrFirst)
    ClearListSTD(DStrStruct, DStrSecond)

    Return(WinProb)

        #undef DesignListHandle
        #undef DesignListHandle1
        break;
      }
    case UFGetDestroyedDesignsList_:
      {
        #define WRace P(0)

    Return( (LLong)Fleet::DestroyedDesigns[WRace] )

        #undef WRace
        break;
      }
    case UFGetComposition_:
      {
        #define WRace P(0)
        #define CompositionType P(1)

    LLong Handle = (LLong)new CompositionIterator(WRace, CompositionType);

    Return (Handle)

        #undef WRace
        #undef CompositionType
        break;
      }
    case UFComplementComposition_:
      {
        #define ShipListHandle P(0)
        #define WRace P(1)
        #define CompositionType P(2)

    LLong Handle = (LLong)new CompositionIterator(WRace, CompositionType, (ShipList*)ShipListHandle);

    Return (Handle)

        #undef ShipListHandle
        #undef WRace
        #undef CompositionType
        break;
      }
    case UFDeleteComposition_:
      {
        #define CompositionHandle P(0)

    CompositionIterator *SL = (CompositionIterator*)CompositionHandle;

    delete SL;

        #undef CompositionHandle
        break;
      }
    case UFGetCompositionDesign_:
      {
        #define N P(0)
        #define CompositionHandle P(1)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    LLong Design = (LLong)Handle->GetNthDesign(N);

    Return (Design)

        #undef N
        #undef CompositionHandle
        break;
      }
    case UFGetCompositionAIType_:
      {
        #define N P(0)
        #define CompositionHandle P(1)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    Return (Handle->GetNthType(N))

        #undef N
        #undef CompositionHandle
        break;
      }
    case UFGetCompositionAIRole_:
      {
        #define N P(0)
        #define CompositionHandle P(1)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    Return (Handle->GetNthRole(N))

        #undef N
        #undef CompositionHandle
        break;
      }
    case UFGetCompositionShipNumber_:
      {
        #define N P(0)
        #define CompositionHandle P(1)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    Return (Handle->GetNthNumberOfShips(N))

        #undef N
        #undef CompositionHandle
        break;
      }
    case UFGetCompositionSize_:
      {
        #define CompositionHandle P(0)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    Return (Handle->NumberOfItems)

        #undef CompositionHandle
        break;
      }
    case UFGetDesignListFromComposition_:
      {
        #define CompositionHandle P(0)

    CompositionIterator *Handle = (CompositionIterator*)CompositionHandle;

    DesignList *DL = NULL;

    for (int i = 0; i<Handle->NumberOfItems; i++)
    {
      for (int k = 0; k<Handle->GetNthNumberOfShips(i); k++)
      {
        DL = new DesignList(Handle->GetNthDesign(i), DL);
      }
    
    }
    
    Return ((LLong)DL)

        #undef CompositionHandle
        break;
      }
    case UFGetStarByID_:
      {
        #define StarID P(0)

    Return((LLong)Star::GetByID(StarID))

        #undef StarID
        break;
      }
    case UFGetStarID_:
      {
        #define StarHandle P(0)

    Star *S = (Star*)StarHandle;

    Return((LLong)S->ID)

        #undef StarHandle
        break;
      }
    case UFCheckStarOwner_:
      {
        #define Handle P(0)
        #define Race P(1)

        Star *ThisStar = (Star*)Handle;
        
        int Result = GetBit(ThisStar->ClearPlanetOwners, Race);
        
        Return(Result ? Yes_ : No_);

        #undef Handle
        #undef Race
        break;
      }
    case UFCheckEnemyStarOwner_:
      {
        #define Handle P(0)
        #define Race P(1)

        Star *ThisStar = (Star*)Handle;

        int Result = GetMask(ThisStar->ClearPlanetOwners, GetRaceInfo(Race).Enemies);
        
        Return(Result ? Yes_ : No_);

        #undef Handle
        #undef Race
        break;
      }
    case UFStarOwnerPaysTribute_:
      {
        #define Handle P(0)
        #define WRace P(1)

        Star *ThisStar = (Star*)Handle;
        LLong PaysTribute = No_;

        for (int i = 0; i<ThisStar->NumPlanets; i++)
        {
          if (ThisStar->Planets[i].Owner!=Race::NoOnes && ThisStar->Planets[i].Owner!=WRace && RaceInfo[ThisStar->Planets[i].Owner].TributeAmount[WRace]>0.0f)
          {
            PaysTribute = Yes_;
            break;
          }
        }

        Return(PaysTribute)

        #undef Handle
        #undef WRace
        break;
      }
    case UFGetStarName_:
      {
        #define Handle P(0)

        Star *ThisStar = (Star*)Handle;
        
        if (ThisStar)
        {
          const char *Result = (const char*)ThisStar->descr_name;
          
          Return(Result);
        }
        else
        {
          Return("NULL");
        }  

        #undef Handle
        break;
      }
    case UFGetStarHandleByName_:
      {
        #define StarName PS(0)

        Star *ThisStar = Star::FindDescrName(StarName);

        if (!ThisStar)
          ThisStar = Star::Find(StarName);

        LLong Result = (LLong)ThisStar;
          
        Return(Result);

        #undef StarName
        break;
      }
    case UFGetPlanetsNum_:
      {
        #define StarHandle P(0)

    Star *ThisStar = (Star*)StarHandle;
    
    Return((LLong)ThisStar->NumPlanets)

        #undef StarHandle
        break;
      }
    case UFStarMakeNova_:
      {
        #define StarHandle P(0)

    Star *ThisStar = (Star*)StarHandle;

    ThisStar->MakeNova();

        #undef StarHandle
        break;
      }
    case UFGetPlanet_:
      {
        #define StarHandle P(0)
        #define PlanetNum P(1)

    Star *ThisStar = (Star*)StarHandle;
    
    if (PlanetNum<ThisStar->NumPlanets)
    {
      Return((LLong)(&ThisStar->Planets[PlanetNum]))
    }
    else
    {
      Return(0);
    }

        #undef StarHandle
        #undef PlanetNum
        break;
      }
    case UFIsNoOnesStar_:
      {
        #define StarHandle P(0)
        #define CheckFleet P(1)

    Star *ThisStar = (Star*)StarHandle;
    
    if (ThisStar->CurrentPlanetOwners==Bit(Race::NoOnes) || ThisStar->CurrentPlanetOwners==0)
    {
      if (Yes_==CheckFleet)
      {
        if (0==ThisStar->CompleteFleetOwners)
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }
      }
      else
      {
        Return(Yes_)
      }
    }
    else
    {
      Return(No_)
    }


        #undef StarHandle
        #undef CheckFleet
        break;
      }
    case UFIsHomeStarForRace_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

        Star *ThisStar = (Star*)StarHandle;

        bool HomeFound = false;

        ForEachPlanet(ThisStar, Pl)
        {
          if (Pl->HomeworldForRace==WRace)
          {
            HomeFound = true;
            break;
          }
        }

        if (HomeFound)
        {
          Return(Yes_)
        }
        else
        {
          Return(No_)
        }

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFStarSelected_:
      {
        #define StarHandle P(0)

    Star *ThisStar = (Star*)StarHandle;
        
    if (ThisStar==Galaxy::SelectedStar())
    {
      Return(Yes_);
    }
    else
    {
      Return(No_);
    }


        #undef StarHandle
        break;
      }
    case UFGetSelectedStar_:
      {

    LLong Handle = (LLong)Galaxy::SelectedStar();
    
    Return (Handle)

        break;
      }
    case UFStarIsVisitedBy_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;
    
    if (ThisStar->WasVisitedBy(WRace))
    {
      Return(Yes_)
    }
    else
    {
      Return(No_)
    }

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFStarSetVisitedBy_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;
        
    ThisStar->Visit(WRace);

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFAllStarsSetVisitedBy_:
      {
        #define WRace P(0)

    ForEachStar(ThisStar)
    {
      ThisStar->Visit(WRace);
    }

        #undef WRace
        break;
      }
    case UFGetPresentFleetsAStrX1000_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;

    float AStrTotal = 0.0f;
    float AStr;
    float DStr;

    ForEachFleetInList(Fl, ThisStar->OrbitingFleets)
    {
      if (Fl->Owner==WRace)
      {
        GetFleetADStr(Fl, AStr, DStr);
        AStrTotal+=AStr;
      }
    }

    int Result = 1000.0f*AStrTotal;
    Return(Result);

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFGetPresentFleetsDStrX10_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;

    float DStrTotal = 0.0f;
    float AStr;
    float DStr;

    ForEachFleetInList(Fl, ThisStar->OrbitingFleets)
    {
      if (Fl->Owner==WRace)
      {
        GetFleetADStr(Fl, AStr, DStr);
        DStrTotal+=DStr;
      }
    }

    int Result = 10.0f*DStrTotal;
    Return(Result);

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFGetClosestSafeStar_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;
        
    Star *Safe = GetClosestSafeStarOfRace(ThisStar, WRace, WRace);
    ClearSortedStarMaps();

    Return((LLong)Safe);

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFHasAttackersAtStar_:
      {
        #define StarHandle P(0)
        #define WRace P(1)

    Star *ThisStar = (Star*)StarHandle;

    int Ret = No_;
    
    ForEachFleetInList(Fl, ThisStar->OrbitingFleets)
    {
      if (Fl->Owner==WRace)
      {
//        EventsMonitor::AddEvent(journalFoodCriticallyLow_, "fleet");

        for (SpaceShip *Sh = Fl->Ships; Sh; Sh = Sh->Next)
        {
          if (Sh->AIIsAttackerExt() || Sh->AITypeIs(aisInvader))
          {
//            EventsMonitor::AddEvent(journalFoodCriticallyLow_, "attacker!");
            Ret = Yes_;
            break;
          }
        }
      }
      
      if (Ret==Yes_)
        break;
    }

    Return(Ret);

        #undef StarHandle
        #undef WRace
        break;
      }
    case UFStarVisibleOnMap_:
      {
        #define Handle P(0)

    Star *WStar = (Star*)Handle;
    
    GCStar Obj;
    Obj.SetStar(WStar);

    Return (Galaxy::ObjectVisibleOnMap(Obj) ? Yes_ : No_)

        #undef Handle
        break;
      }
    case UFConnectStars_:
      {
        #define StarHandle1 P(0)
        #define StarHandle2 P(1)
        #define ThisTonnelLength P(2)
        #define ThisLifeTime P(3)

    // -1 LifeTime for permanent connection
    // -1 TonnelLength for Average tunnel length
    // 0 TonnelLength for actual length
    Star *Star1 = (Star*)StarHandle1;
    Star *Star2 = (Star*)StarHandle2;

    
    int LifeTime = ThisLifeTime;
    int Length = ThisTonnelLength;

    if (Length==0)
      Length = GetDistance( Star1->Location, Star2->Location );
    else
    {
      if (Length<0)
        Length = Galaxy::averageConnectionLength;
    }
    
    Connect(Star1, Star2, Length, LifeTime);

    if (Star1->GCRef)
      Star1->GCRef->AddConnection(Star2->GCRef, Length, LifeTime);

        #undef StarHandle1
        #undef StarHandle2
        #undef ThisTonnelLength
        #undef ThisLifeTime
        break;
      }
    case UFStarGetNumConnections_:
      {
        #define StarHandle P(0)

        Star *ThisStar = (Star*)StarHandle;

        int Count = 0;

        ForEachConnection(Conn, ThisStar)
        {
          Count++;
        }

        Return(Count)

        #undef StarHandle
        break;
      }
    case UFStarGetNthConnections_:
      {
        #define StarHandle P(0)
        #define _N P(1)

        Star *ThisStar = (Star*)StarHandle;

        Star *ConnStar = NULL;
        int N = _N;

        ForEachConnection(Conn, ThisStar)
        {
          if (N<=0)
          {
            ConnStar = Conn->To;
            break;
          }
          else
            N--;
        }

        Return((LLong)ConnStar)

        #undef StarHandle
        #undef _N
        break;
      }
    case UFAddWormholeConnection_:
      {
        #define StarHandle1 P(0)
        #define StarHandle2 P(1)

    Star *Star1 = (Star*)StarHandle1;
    Star *Star2 = (Star*)StarHandle2;

    Star1->AddWormhole(Star2);

        #undef StarHandle1
        #undef StarHandle2
        break;
      }
    case UFWormholeTested_:
      {
        #define WRace P(0)
        #define StarHandle1 P(1)
        #define StarHandle2 P(2)
        #define LeadedToStar P(3)

    Star *Star1 = (Star*)StarHandle1;
    Star *Star2 = (Star*)StarHandle2;
    Star *Leaded = (Star*)LeadedToStar;

    InstantConnection *W = Star1->FindWormholeTo(Star2);

    if (!W)
      W = Star1->AddWormhole(Star2);

    SetBit(W->KnownFor, WRace);

    if (WRace==PlayerRace && Leaded!=Star2)
      W->LastPlayerTo = Leaded;

        #undef WRace
        #undef StarHandle1
        #undef StarHandle2
        #undef LeadedToStar
        break;
      }
    case UFWormholeTestedEndLink_:
      {
        #define StarHandle1 P(0)
        #define StarHandle2 P(1)

    Star *Star1 = (Star*)StarHandle1;
    Star *Star2 = (Star*)StarHandle2;

    InstantConnection *W = Star1->FindWormholeTo(Star2);

    if (!W)
      W = Star1->AddWormhole(Star2);

    W->KnownFor |= Star2->CompleteCurrentOwners();

        #undef StarHandle1
        #undef StarHandle2
        break;
      }
    case UFInitTestBattle_:
      {
        #define FirstRace P(0)
        #define AliensRace P(1)

        InitTestBattle(FirstRace, AliensRace);

        #undef FirstRace
        #undef AliensRace
        break;
      }
    case UFAddOneShipForTestBattle_:
      {
        #define FirstSide P(0)
        #define DesignHandle P(1)

        LLong Ship = (LLong)AddOneShipForTestBattle(Yes_==FirstSide, (Ship_Design *)DesignHandle);

        Return (Ship)

        #undef FirstSide
        #undef DesignHandle
        break;
      }
    case UFAddHangarShipForTestBattle_:
      {
        #define FirstSide P(0)
        #define DesignHandle P(1)
        #define MotherShipHandle P(2)
        #define CheckHangarSpace P(3)

        bool Result = AddHangarShipForTestBattle(Yes_==FirstSide, (Ship_Design *)DesignHandle, (ShipInfoStruct *)MotherShipHandle, Yes_==CheckHangarSpace);

        Return (Result ? Yes_ : No_)

        #undef FirstSide
        #undef DesignHandle
        #undef MotherShipHandle
        #undef CheckHangarSpace
        break;
      }
    case UFStartTestBattle_:
      {
        #define MayReorderFleet P(0)

        // 0 means Player won, 1 - Player lost, -1 means battle cannot start as the battle data is not properly initialised.
        int BatRes = StartTestBattle((Yes_==MayReorderFleet));

        Return (BatRes)

        #undef MayReorderFleet
        break;
      }
    case UFPhantomBattle_:
      {
        #define Race P(0)

        // 0 means Player won, 1 - Player lost
        int BatRes = PhantomBattle(Race);

        Return (BatRes)

        #undef Race
        break;
      }
    case UFStartShipProductionForPlayer_:
      {
        #define RaceID P(0)
        #define DesignHandle P(1)

        Ship_Design *ThisDesign = (Ship_Design*)DesignHandle;
        AIShipList *AIShip = new AIShipList(aisUserShip, adpMultipurpose, RaceID, soWait, NULL);
        AIShip->Build = ThisDesign;
        AIPrioritize(RaceID, AIShip);

        #undef RaceID
        #undef DesignHandle
        break;
      }
    case UFMergeEmpires_:
      {
        #define Race0 P(0)
        #define Race1 P(1)


        if (Race1==PlayerRace)
        {
          NormalizeConsumption(Race0);
        }

        ForEachStar(S)
        {
          for (int pl = 0; pl<S->NumPlanets; pl++)
          if (S->Planets[pl].Owner==Race0)
          {
            S->InvadeColony(pl, Race1, 0, false);
//            ChangeECOPlanetOwner(S, pl, Race1, MAX_COLONIST_AMOUNT, false);
          }

          if (S->WasVisitedBy(Race0))
            S->Visit(Race1);
        }
        
        SetBit(RaceInfo[Race1].MergedRaces, Race0);
        RaceInfo[Race1].MergedRaces |= RaceInfo[Race0].MergedRaces;
        
        if (Race1==PlayerRace)
        {
          RaceInfo[PlayerRace].JoinedPlayerDate = Galaxy::Time;
          
          UpdateDesignsForPlayer(Race0);

          ForEachFleet(This)
          {
            if (This->Owner==Race0)
            {
              if (This->PhantomDisinfo)
              {
                This->Kill();
              }
              else
              {
                This->Owner=Race1;

                SpaceShip *Ship = This->Ships;

                while (Ship)
                {
                  Ship->AIInfo.ShipType = aisUserShip;
                  Ship->AIInfo.ShipOrder = soWait;
                  Ship->Owner = Race1;

                  SpaceShip *Internal = Ship->inner;

                  while (Internal)
                  {
                    Internal->AIInfo.ShipType = aisUserShip;
                    Internal->AIInfo.ShipOrder = soWait;
                    Internal->Owner = Race1;
                    Internal = Internal->Next;
                  }

                  Ship = Ship->Next;
                }
              }
            }            
          }
        }


        #undef Race0
        #undef Race1
        break;
      }
    case UFShowMineralsInfo_:
      {
        #define DoShow P(0)

        E1PShowMineralsInfo(Yes_==DoShow);

        #undef DoShow
        break;
      }
    case UFShowTradeAgreements_:
      {
        #define DoShow P(0)

        E1PShowTradeAgreements(Yes_==DoShow);

        #undef DoShow
        break;
      }
    case UFAddSpecialContaner_:
      {
        #define StarHandle P(0)
        #define InGameContainerType P(1)
        #define ContentType P(2)
        #define ContentAmount P(3)

        Star *S = (Star*)StarHandle;

        if (SpaceContainer::NumSpecialContainers>0)
        {
          int Type = InGameContainerType;

          if (E1_UNDEFINED==Type)
            Type = rand() % SpaceContainer::NumSpecialContainers;
            
          AddSpecialContaner(S, Type, ContentType, ContentAmount);
        }

        #undef StarHandle
        #undef InGameContainerType
        #undef ContentType
        #undef ContentAmount
        break;
      }
    case UFGetContainerContentType_:
      {
        #define ContainerHandle P(0)

        SpaceContainer *Cont = (SpaceContainer*)ContainerHandle;

        Return(Cont->AIInfo.GetContentType())

        #undef ContainerHandle
        break;
      }
    case UFGetContainerContentAmount_:
      {
        #define ContainerHandle P(0)

        SpaceContainer *Cont = (SpaceContainer*)ContainerHandle;

        Return(Cont->AIInfo.GetContentAmount())

        #undef ContainerHandle
        break;
      }
    case UFNewShipPart_:
      {
        #define DesignHandle P(0)
        #define Owner P(1)


      SpaceShip *Tmp = new SpaceShip((Ship_Design*)DesignHandle, Owner);
      SpaceContainer *Result = new SpaceContainer(Tmp);
      delete Tmp;

      Return((LLong)Result)

        #undef DesignHandle
        #undef Owner
        break;
      }
    case UFNewShipPartByShip_:
      {
        #define ShipHandle P(0)

      SpaceContainer *Result = new SpaceContainer((SpaceShip*)ShipHandle);

      Return((LLong)Result)

        #undef ShipHandle
        break;
      }
    case UFCreateNewHero_:
      {
        #define Name PS(0)
        #define ImageFile PS(1)
        #define BigImageFile PS(2)

        SpaceHero *Hero = new SpaceHero((char*)(const char*)Name, (char*)(const char*)ImageFile, (char*)(const char*)BigImageFile);

        Return((LLong)Hero);

        #undef Name
        #undef ImageFile
        #undef BigImageFile
        break;
      }
    case UFAddHeroDescription_:
      {
        #define Handle P(0)
        #define Descr PS(1)

        SpaceHero *Hero = (SpaceHero*)Handle;
        Hero->Description = (const char*)Descr;

        #undef Handle
        #undef Descr
        break;
      }
    case UFAddHeroProperty_:
      {
        #define Handle P(0)
        #define Type P(1)
        #define Value P(2)

        SpaceHero *Hero = (SpaceHero*)Handle;
        int ValueI_ = Value;
        Hero->Properties = new HeroParameter(Type, ValueI_, Hero->Properties);

        #undef Handle
        #undef Type
        #undef Value
        break;
      }
    case UFAddHeroPropertyF_:
      {
        #define Handle P(0)
        #define Type P(1)
        #define Value P(2)
        #define Divider P(3)

        SpaceHero *Hero = (SpaceHero*)Handle;

        float ValueF = (float)Value / (float)Divider;
        Hero->Properties = new HeroParameter(Type, ValueF, Hero->Properties);

        #undef Handle
        #undef Type
        #undef Value
        #undef Divider
        break;
      }
    case UFAddHeroPropertyDual_:
      {
        #define Handle P(0)
        #define Type P(1)
        #define ValueI P(2)
        #define ValueF P(3)
        #define Divider P(4)

        SpaceHero *Hero = (SpaceHero*)Handle;

        int ValueI_ = ValueI;
        float ValueF_ = (float)ValueF / (float)Divider;
        Hero->Properties = new HeroParameter(Type, ValueI_, ValueF_, Hero->Properties);

        #undef Handle
        #undef Type
        #undef ValueI
        #undef ValueF
        #undef Divider
        break;
      }
    case UFAddHeroToPlanet_:
      {
        #define PlanetHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        Planet *Pl = (Planet*)PlanetHandle;
        Pl->AddHeroes(Hero);

        #undef PlanetHandle
        #undef HeroHandle
        break;
      }
    case UFDelHeroFromPlanet_:
      {
        #define PlanetHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        Planet *Pl = (Planet*)PlanetHandle;
        Pl->DelHero(Hero);

        #undef PlanetHandle
        #undef HeroHandle
        break;
      }
    case UFAddHeroToShip_:
      {
        #define ShipHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        SpaceShip *Sh = (SpaceShip*)ShipHandle;
        Sh->AddHeroes(Hero);

        #undef ShipHandle
        #undef HeroHandle
        break;
      }
    case UFDelHeroFromShip_:
      {
        #define ShipHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        SpaceShip *Sh = (SpaceShip*)ShipHandle;
        Sh->DelHero(Hero);

        #undef ShipHandle
        #undef HeroHandle
        break;
      }
    case UFAddHeroToFleet_:
      {
        #define FleetHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        Fleet *Fl = (Fleet*)FleetHandle;
        bool Result = Fl->AddHeroes(Hero);

        Return( (Result ? Yes_ : No_))

        #undef FleetHandle
        #undef HeroHandle
        break;
      }
    case UFDelHeroFromFleet_:
      {
        #define FleetHandle P(0)
        #define HeroHandle P(1)

        SpaceHero *Hero = (SpaceHero*)HeroHandle;
        Fleet *Fl = (Fleet*)FleetHandle;
        bool Result = Fl->DelHero(Hero);

        Return( (Result ? Yes_ : No_))

        #undef FleetHandle
        #undef HeroHandle
        break;
      }
    case UFStarHasHero_:
      {
        #define StarHandle P(0)
        #define HeroName PS(1)

        Star *S = (Star*)StarHandle;
        Planet *Found = NULL;

        for (int i = 0; i<S->NumPlanets && !Found; i++)
        {
          for (SpaceHero *Cur = S->Planets[i].HeroesPresent; Cur; Cur = Cur->Next)
          {
            if (!strcmp((const char*)Cur->Name, (const char*)HeroName))
            {
              Found = &S->Planets[i];
              break;
            }
          }
        }

        Return((LLong)Found)

        #undef StarHandle
        #undef HeroName
        break;
      }
    case UFPlanetHasHero_:
      {
        #define PlanetHandle P(0)
        #define HeroName PS(1)

        Planet *Pl = (Planet*)PlanetHandle;
        bool Found = false;

        for (SpaceHero *Cur = Pl->HeroesPresent; Cur; Cur = Cur->Next)
        {
          if (!strcmp((const char*)Cur->Name, (const char*)HeroName))
          {
            Found = true;
            break;
          }
        }

        Return(Found ? Yes_ : No_)

        #undef PlanetHandle
        #undef HeroName
        break;
      }
    case UFFleetHasHero_:
      {
        #define FleetHandle P(0)
        #define HeroName PS(1)

        Fleet *Fl = (Fleet*)FleetHandle;
        SpaceShip *Found = NULL;

        for (SpaceShip *Sh = Fl->Ships; Sh && !Found; Sh = Sh->Next)
        {
          for (SpaceHero *Cur = Sh->heroes; Cur; Cur = Cur->Next)
          {
            if (!strcmp((const char*)Cur->Name, (const char*)HeroName))
            {
              Found = Sh;
              break;
            }
          }
        }

        Return((LLong)Found)

        #undef FleetHandle
        #undef HeroName
        break;
      }
    case UFShipHasHero_:
      {
        #define ShipHandle P(0)
        #define HeroName PS(1)

        SpaceShip *Sh = (SpaceShip*)ShipHandle;
        bool Found = false;

        for (SpaceHero *Cur = Sh->heroes; Cur; Cur = Cur->Next)
        {
          if (!strcmp((const char*)Cur->Name, (const char*)HeroName))
          {
            Found = true;
            break;
          }
        }

        Return(Found ? Yes_ : No_)

        #undef ShipHandle
        #undef HeroName
        break;
      }
    case UFGetShipType_:
      {
        #define Handle P(0)

        SpaceShip *Ship = (SpaceShip*)Handle;
        
        int Result = Ship->Type->ship_body->Get_Type()->typeNo;
        
        Return(Result);

        #undef Handle
        break;
      }
    case UFGetShipDesign_:
      {
        #define Handle P(0)

        SpaceShip *Ship = (SpaceShip*)Handle;
        
        Return((LLong)Ship->Type);

        #undef Handle
        break;
      }
    case UFGetShipDesignType_:
      {
        #define Handle P(0)

        Ship_Design *Des = (Ship_Design*)Handle;
        
        int Result = Des->ship_body->Get_Type()->typeNo;
        
        Return(Result);

        #undef Handle
        break;
      }
    case UFGetAIShipDesign_:
      {
        #define Race P(0)
        #define Role P(1)
        #define Modification P(2)

        // Use only for AI races!!!
        Return( (LLong)GetAIDesign(Race, Role, Modification))

        #undef Race
        #undef Role
        #undef Modification
        break;
      }
    case UFGetShipDesignByName_:
      {
        #define DesignName PS(0)
        #define WRace P(1)

        // will return 0 if design not found
        // pass -1 as WRace to search in all designs
        char *Trans = SearchInitialDesign((char*)(const char*)DesignName);
        
        if (Trans)
        {
          Return((LLong)findDesign(Trans, WRace))
        }
        else
        {
          Return((LLong)findDesign(DesignName, WRace))
        }

        #undef DesignName
        #undef WRace
        break;
      }
    case UFGetShipDesignName_:
      {
        #define Handle P(0)

        Ship_Design *Des = (Ship_Design*)Handle;
        
        const char *Result = (const char*)Des->name;
        
        Res = Result;

        #undef Handle
        break;
      }
    case UFShipTypeNames_:
      {
        #define TypeNo P(0)

        Res = typeName(TypeNo);

        #undef TypeNo
        break;
      }
    case UFGetResForShipDesign_:
      {
        #define WRace P(0)
        #define ShipDesignHandle P(1)
        #define ResType P(2)
        #define Mult P(3)

        Ship_Design *ThisDesign = (Ship_Design*)ShipDesignHandle;
        
        float fMult = Mult;

        float fResult = 0;
        
        if (ThisDesign)
        {
          for (int i = 0; i<ThisDesign->resourceReqCount; i++)
          {
            if (ThisDesign->resourceReqType[i] == ResType)
            {
              fResult = fMult*ThisDesign->resourceReq[i]*GetRaceInfo(WRace).GetBldMultiplierForShip(ResType)*ThisDesign->Get_Body()->Get_Type()->StdBuildMultiplier;
              break;
            }
          }
        }
        
        int Result = fResult;

        Return(Result)
        

        #undef WRace
        #undef ShipDesignHandle
        #undef ResType
        #undef Mult
        break;
      }
    case UFGetBuildMinTime_:
      {
        #define ShipDesignHandle P(0)
        #define Race P(1)

        Ship_Design *ThisDesign = (Ship_Design*)ShipDesignHandle;
        int MinProd;
        int MaxProd;
        
        GetBuildMinMax(ThisDesign, MinProd, MaxProd, Race, true);
        
        Return(MinProd);

        #undef ShipDesignHandle
        #undef Race
        break;
      }
    case UFNewShip_:
      {
        #define DesignHandle P(0)
        #define Owner P(1)

      SpaceShip *Result = new SpaceShip((Ship_Design*)DesignHandle, Owner);
      
      Return((LLong)Result)

        #undef DesignHandle
        #undef Owner
        break;
      }
    case UFSetShipAIType_:
      {
        #define ShipHandle P(0)
        #define Type P(1)

      SpaceShip *Sh = (SpaceShip*)ShipHandle;

      Sh->AIInfo.ShipType = Type;
      Sh->AIInfo.ShipRole = adpMultipurpose;
      Sh->AIInfo.Reset();

        #undef ShipHandle
        #undef Type
        break;
      }
    case UFSetShipAITypeAndRole_:
      {
        #define ShipHandle P(0)
        #define Type P(1)
        #define Role P(2)

      SpaceShip *Sh = (SpaceShip*)ShipHandle;

      Sh->AIInfo.ShipType = Type;
      Sh->AIInfo.ShipRole = Role;
      Sh->AIInfo.Reset();

        #undef ShipHandle
        #undef Type
        #undef Role
        break;
      }
    case UFShipAddToHangars_:
      {
        #define MotherShipHandle P(0)
        #define FighterShipHandle P(1)

      SpaceShip *Mother = (SpaceShip*)MotherShipHandle;
      SpaceShip *Sh = (SpaceShip*)FighterShipHandle;
      
      Mother->AddToHangars(Sh);

        #undef MotherShipHandle
        #undef FighterShipHandle
        break;
      }
    case UFShipCanAddToHangars_:
      {
        #define MotherShipHandle P(0)
        #define FighterShipHandle P(1)

      SpaceShip *Mother = (SpaceShip*)MotherShipHandle;
      SpaceShip *Sh = (SpaceShip*)FighterShipHandle;
      
      if (Mother->hangarSpaceLeft>=Sh->Type->spaceInHangar())
      {
        Return(Yes_)
      }
      else
      {
        Return(No_)
      }

        #undef MotherShipHandle
        #undef FighterShipHandle
        break;
      }
    case UFShipCanAddToHangarsDesign_:
      {
        #define MotherShipHandle P(0)
        #define FighterDesignHandle P(1)

      SpaceShip *Mother = (SpaceShip*)MotherShipHandle;
      Ship_Design *Des = (Ship_Design*)FighterDesignHandle;
      
      if (Mother->hangarSpaceLeft>=Des->spaceInHangar())
      {
        Return(Yes_)
      }
      else
      {
        Return(No_)
      }

        #undef MotherShipHandle
        #undef FighterDesignHandle
        break;
      }
    case UFShipAddToCargoBay_:
      {
        #define MotherShipHandle P(0)
        #define ContainerHandle P(1)

      SpaceShip *Mother = (SpaceShip*)MotherShipHandle;
      SpaceContainer *Cont = (SpaceContainer*)ContainerHandle;
      
      Mother->AddToHangars(Cont);

        #undef MotherShipHandle
        #undef ContainerHandle
        break;
      }
    case UFShipCanAddToCargoBay_:
      {
        #define MotherShipHandle P(0)
        #define ContainerHandle P(1)

      SpaceShip *Mother = (SpaceShip*)MotherShipHandle;
      SpaceContainer *Cont = (SpaceContainer*)ContainerHandle;

      if ((!Cont && Mother->Type->containerSpace>0) || (Cont && Mother->containerSpaceLeft>=Cont->IsContainer->space))
      {
        Return(Yes_)
      }
      else
      {
        Return(No_)
      }

        #undef MotherShipHandle
        #undef ContainerHandle
        break;
      }
    case UFGetDesignAStrX1000_:
      {
        #define DesignHandle P(0)

    Ship_Design *Des = (Ship_Design*)DesignHandle;

    float AStr;
    float DStr;

    DesignADStr(Des, AStr, DStr);

    int Result = 1000.0f*AStr;
    Return(Result);

        #undef DesignHandle
        break;
      }
    case UFGetDesignDStrX10_:
      {
        #define DesignHandle P(0)

    Ship_Design *Des = (Ship_Design*)DesignHandle;

    float AStr;
    float DStr;

    DesignADStr(Des, AStr, DStr);

    int Result = 10.0f*DStr;
    Return(Result);

        #undef DesignHandle
        break;
      }
    case UFGetFleetByShip_:
      {
        #define StarHandle P(0)
        #define ShipHandle P(1)

    Star *S = (Star*)StarHandle;
    SpaceShip *Sh = (SpaceShip*)ShipHandle;
    SpaceShip *MotherShip = NULL;

    Fleet *Found = NULL;

    if (S)
    {
      ForEachOrbitingOrHiddenFleet(Fl, S)
      {
        if (Fl->SearchShip(Sh, MotherShip))
        {
          Found = Fl;
          break;
        }
      }
    }
    else
    {
      Found = Fleet::SearchAll(Sh, MotherShip);
    }

    Return((LLong)Found);

        #undef StarHandle
        #undef ShipHandle
        break;
      }
    case UFPrintToJournal_:
      {
        #define Code P(0)
        #define JournalText PS(1)

        EventsMonitor::AddEvent(Code, JournalText);

        #undef Code
        #undef JournalText
        break;
      }
    case UFPrintToJournalFleet_:
      {
        #define Code P(0)
        #define JournalText PS(1)
        #define Handle P(2)

        EventsMonitor::AddFleetEvent(Code, JournalText, (Fleet*)Handle);

        #undef Code
        #undef JournalText
        #undef Handle
        break;
      }
    case UFPrintToJournalPlanet_:
      {
        #define Code P(0)
        #define JournalText PS(1)
        #define Handle P(2)

        EventsMonitor::AddPlanetEvent(Code, JournalText, (Planet*)Handle);

        #undef Code
        #undef JournalText
        #undef Handle
        break;
      }
    case UFPrintToJournalStar_:
      {
        #define Code P(0)
        #define JournalText PS(1)
        #define Handle P(2)

        EventsMonitor::AddStarEvent(Code, JournalText, (Star*)Handle);

        #undef Code
        #undef JournalText
        #undef Handle
        break;
      }
    case UFPrintToJournalTech_:
      {
        #define Code P(0)
        #define JournalText PS(1)
        #define Handle P(2)

        EventsMonitor::AddTechEvent(Code, JournalText, (Technology*)Handle);

        #undef Code
        #undef JournalText
        #undef Handle
        break;
      }
    case UFRegisterJournalCode_:
      {
        #define Code P(0)
        #define CodeDesription PS(1)
        #define Icon PS(2)
        #define SoundCode P(3)

        EventsMonitor::AddCode(Code, CodeDesription, Icon, SoundCode);

        #undef Code
        #undef CodeDesription
        #undef Icon
        #undef SoundCode
        break;
      }
    case UFRegisterJournalSubCode_:
      {
        #define Parent P(0)
        #define Code P(1)
        #define CodeDesription PS(2)
        #define Icon PS(3)

        EventsMonitor::AddCode(Code, CodeDesription, Icon);
        EventsMonitor::SetCodeParent(Code, Parent);

        #undef Parent
        #undef Code
        #undef CodeDesription
        #undef Icon
        break;
      }
    case UFSetJournalCodeSound_:
      {
        #define Code P(0)
        #define NewSoundCode P(1)

        EMonitorCode *This = EventsMonitor::SearchByCode(Code);

        if (This)
        {
          This->SoundCode = NewSoundCode;
        }

        #undef Code
        #undef NewSoundCode
        break;
      }
    case UFSetJournalCodeSoundSpecial_:
      {
        #define Code P(0)
        #define SoundName PS(1)

        EMonitorCode *This = EventsMonitor::SearchByCode(Code);

        if (This)
        {
          This->SpecialSound = LoadLWFile(SoundName);
        }

        #undef Code
        #undef SoundName
        break;
      }
    case UFSetJournalCodePausing_:
      {
        #define Code P(0)
        #define DoPause P(1)

        EMonitorCode *This = EventsMonitor::SearchByCode(Code);

        if (This)
        {
          This->Pause = (Yes_==DoPause);
        }

        #undef Code
        #undef DoPause
        break;
      }
    case UFSetJournalCodeIgnoring_:
      {
        #define Code P(0)
        #define DoIgnore P(1)

        EMonitorCode *This = EventsMonitor::SearchByCode(Code);

        if (This)
        {
          This->Ignore = (Yes_==DoIgnore);
        }

        #undef Code
        #undef DoIgnore
        break;
      }
    case UFShowEventsMonitor_:
      {

        EventsMonitor::Showing = true;

        break;
      }
    case UFCloseEventsMonitor_:
      {

        EventsMonitor::Hide();

        break;
      }
    case UFRegisterResource_:
      {
        #define ResID P(0)
        #define ResClass P(1)
        #define RStrID PS(2)
        #define RName PS(3)

    int RID = ResID;

    if (resCount<=RID)
      resCount = RID + 1;
      
    AllRes[RID].RClass = ResClass;
    AllRes[RID].SetTypeID(RStrID);
    AllRes[RID].SetName(RName);

        #undef ResID
        #undef ResClass
        #undef RStrID
        #undef RName
        break;
      }
    case UFSetResourceDescription_:
      {
        #define ResID P(0)
        #define DescriptionText PS(1)

    int RID = ResID;

    AllRes[RID].SetDescription(DescriptionText);

        #undef ResID
        #undef DescriptionText
        break;
      }
    case UFSetResourceIcon_:
      {
        #define ResID P(0)
        #define IconName PS(1)
        #define _DrawInPreview P(2)

    int RID = ResID;

    AllRes[RID].SetIcon(IconName);
    AllRes[RID].DrawInPreview = (Yes_==_DrawInPreview);

        #undef ResID
        #undef IconName
        #undef _DrawInPreview
        break;
      }
    case UFSetStdConsumptionPerPerson_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i].ConsumptionPerPerson[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificConsumptionPerPerson_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).ConsumptionPerPerson[ResID] = FValue / (float)Divider;

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificConsumptionPerPerson_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).ConsumptionPerPerson[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetStdShipConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i]._ConsumptionMultiplierForShip[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificShipConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._ConsumptionMultiplierForShip[ResID] = (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificShipConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._ConsumptionMultiplierForShip[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetStdShipRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i]._BldMultiplierForShip[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificShipRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._BldMultiplierForShip[ResID] = (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificShipRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._BldMultiplierForShip[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetStdBuildingConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i]._ConsumptionMultiplierForBuilding[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificBuildingConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._ConsumptionMultiplierForBuilding[ResID] = (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificBuildingConsumptionModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._ConsumptionMultiplierForBuilding[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetStdBuildingRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i]._BldMultiplierForBuilding[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificBuildingRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._BldMultiplierForBuilding[ResID] = (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificBuildingRequiredModifier_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace)._BldMultiplierForBuilding[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetRaceSpecificSpyingEfficiency_:
      {
        #define Amount P(0)
        #define Divider P(1)
        #define WRace P(2)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).SpyingEfficiency = (FValue / (float)Divider);

        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetRaceSpecificTradeEfficiency_:
      {
        #define Amount P(0)
        #define Divider P(1)
        #define WRace P(2)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).TradeEfficiency = (FValue / (float)Divider);

        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFResourceNames_:
      {
        #define TypeNo P(0)

        Res = AllRes[TypeNo].Name;
        
//#ifndef USE_CP1251
//        cp866_cp1251(Res.ToStr());
//#endif        

        #undef TypeNo
        break;
      }
    case UFSetStdEmptyPlanetProduction_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)

    float FValue = (float)Amount;
    FValue = FValue / (float)Divider;
    
    for (int i = 0; i<Race::MaxNumber; i++)
      RaceInfo[i].EmptyPlanetProduction[ResID] = FValue;

        #undef ResID
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetRaceSpecificEmptyPlanetProduction_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).EmptyPlanetProduction[ResID] = FValue / (float)Divider;

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificEmptyPlanetProduction_:
      {
        #define ResID P(0)
        #define Amount P(1)
        #define Divider P(2)
        #define WRace P(3)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).EmptyPlanetProduction[ResID]*= (FValue / (float)Divider);

        #undef ResID
        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetRaceSpecificWorkEfficiencyCoeff_:
      {
        #define Amount P(0)
        #define Divider P(1)
        #define WRace P(2)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).WorkEfficiencyCoeff = FValue / (float)Divider;

        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFAlterRaceSpecificWorkEfficiencyCoeff_:
      {
        #define Amount P(0)
        #define Divider P(1)
        #define WRace P(2)

    float FValue = (float)Amount;
    GetRaceInfo(WRace).WorkEfficiencyCoeff*= (FValue / (float)Divider);

        #undef Amount
        #undef Divider
        #undef WRace
        break;
      }
    case UFSetDifficultyLevelProductionModifier_:
      {
        #define GameDifficulty P(0)
        #define ResType P(1)
        #define Amount P(2)
        #define Divider P(3)

    float FValue = (float)Amount;
    AllRes[ResType].SkillLevelProductionModifier[GameDifficulty] = (FValue / (float)Divider);

        #undef GameDifficulty
        #undef ResType
        #undef Amount
        #undef Divider
        break;
      }
    case UFSetDifficultyLevelProductionModifierRClass_:
      {
        #define GameDifficulty P(0)
        #define _RClass P(1)
        #define Amount P(2)
        #define Divider P(3)

    float FValue = (float)Amount;

    FValue = FValue / (float)Divider;

    for (int i = 0; i<resCount; i++)
      if (AllRes[i].RClass==_RClass)
        AllRes[i].SkillLevelProductionModifier[GameDifficulty] = FValue;

        #undef GameDifficulty
        #undef _RClass
        #undef Amount
        #undef Divider
        break;
      }
    case UFRegisterBuilding_:
      {
        #define BldID P(0)
        #define BldStrID PS(1)
        #define BldName PS(2)

    int BID = BldID;
    
    if (bldCount<=BID)
      bldCount = BID + 1;

    AllBuildings[BID].SetTypeID(BldStrID);
    AllBuildings[BID].SetName(BldName);
    SetBit(AllBuildings[BID].Properties, bpEnabled_);

//    BldOutput.Print("ID \"%s\"\n", BldStrID);

        #undef BldID
        #undef BldStrID
        #undef BldName
        break;
      }
    case UFRegisterBuildingFromFile_:
      {
        #define BldID P(0)
        #define FileName PS(1)
        #define BldName PS(2)

//    if (BldOutput.file)
//      BldOutput.Close();
//      
//    BldOutput.Open(FileName, "wt");

    int BID = BldID;
    
    if (bldCount<=BID)
      bldCount = BID + 1;

    AllBuildings[BID].InitFromFile(FileName);
    AllBuildings[BID].SetName(BldName);

    SetBit(AllBuildings[BID].Properties, bpEnabled_);

        #undef BldID
        #undef FileName
        #undef BldName
        break;
      }
    case UFSetBldIcon_:
      {
        #define Bld P(0)
        #define IconName PS(1)

    for (int i = 0; i<Race::MaxNumber; i++)
      AllBuildings[Bld].Icon(i) = GetGif(IconName);

//    BldOutput.Print("  Icon \"%s\"\n", IconName);

        #undef Bld
        #undef IconName
        break;
      }
    case UFSetBldIconRace_:
      {
        #define Bld P(0)
        #define WRace P(1)
        #define IconName PS(2)

    AllBuildings[Bld].Icon(WRace) = GetGif(IconName);

//    BldOutput.Print("  Icon \"%s\"\n", IconName);

        #undef Bld
        #undef WRace
        #undef IconName
        break;
      }
    case UFSetBldDescription_:
      {
        #define Bld P(0)
        #define Text PS(1)

    AllBuildings[Bld].Description = Text;

        #undef Bld
        #undef Text
        break;
      }
    case UFSetBldMiniText_:
      {
        #define Bld P(0)
        #define Text PS(1)

    AllBuildings[Bld].MiniText = Text;

        #undef Bld
        #undef Text
        break;
      }
    case UFBldGetName_:
      {
        #define Bld P(0)

    Return(AllBuildings[Bld].Name);

        #undef Bld
        break;
      }
    case UFBldAllowedByDefault_:
      {
        #define Bld P(0)
        #define Value P(1)

    AllBuildings[Bld].AllowedByDefault = (Value==Yes_);

//    if (Yes_==Value)
//      BldOutput.Print("  AllowedByDefault\n");

        #undef Bld
        #undef Value
        break;
      }
    case UFBldSetExtendedCheck_:
      {
        #define Bld P(0)
        #define Value P(1)

    AllBuildings[Bld].ExtendedMayBuildCheck = (Value==Yes_);

        #undef Bld
        #undef Value
        break;
      }
    case UFMaxBldCountByDefault_:
      {
        #define Bld P(0)
        #define Value P(1)

    AllBuildings[Bld].MaxCountByDefault = Value;

//    BldOutput.Print("  MaxCountByDefault %d\n", Value);

        #undef Bld
        #undef Value
        break;
      }
    case UFAddBldProduction_:
      {
        #define Bld P(0)
        #define ResType P(1)
        #define Value P(2)
        #define Divider P(3)

    float FValue = Value;
    AllBuildings[Bld].AddProductionType(ResType, FValue / (float)Divider);

//    if (ResType==resSpecial_)
//      BldOutput.Print("    Parm %f\n", FValue / (float)Divider);
//    else
//      BldOutput.Print("  Produces %s %f\n", AllRes[ResType].TypeID, FValue / (float)Divider);

        #undef Bld
        #undef ResType
        #undef Value
        #undef Divider
        break;
      }
    case UFBldWorkersRequired_:
      {
        #define Bld P(0)
        #define Value P(1)

    AllBuildings[Bld]._WorkersRequired = Value;

//    BldOutput.Print("  WorkersRequired %d\n", Value);

        #undef Bld
        #undef Value
        break;
      }
    case UFAIBldValue_:
      {
        #define Bld P(0)
        #define Value P(1)
        #define Divider P(2)

    float FValue = Value;
    AllBuildings[Bld]._AIValue = FValue/(float)Divider;

//
//    BldOutput.Print("  AIValue %f\n", FValue / (float)Divider);

        #undef Bld
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddProperty_:
      {
        #define Bld P(0)
        #define PropertyIndex P(1)

    SetBit(AllBuildings[Bld].Properties, PropertyIndex);

//    BldOutput.Print("  Property %s\n", BldPropertyNames[PropertyIndex]);

        #undef Bld
        #undef PropertyIndex
        break;
      }
    case UFBldSetRequiredTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)

    AllBuildings[Bld].SetTechnology(TechID);

//    BldOutput.Print("  RequiredTech \"%s\"\n", TechID);

        #undef Bld
        #undef TechID
        break;
      }
    case UFBldAddRequiredResource_:
      {
        #define Bld P(0)
        #define RType P(1)
        #define Amount P(2)

    float FValue = Amount;
    AllBuildings[Bld].AddResourceReq(RType, FValue);

//    BldOutput.Print("  Requires %s %f\n", AllRes[RType].TypeID, FValue);

        #undef Bld
        #undef RType
        #undef Amount
        break;
      }
    case UFBldAddResourceConsumption_:
      {
        #define Bld P(0)
        #define RType P(1)
        #define Amount P(2)
        #define Divider P(3)

    float FValue = Amount;
    AllBuildings[Bld].AddResourceConsumption(RType, FValue/(float)Divider);

//    BldOutput.Print("  Consumes %s %f\n", AllRes[RType].TypeID, FValue / (float)Divider);

        #undef Bld
        #undef RType
        #undef Amount
        #undef Divider
        break;
      }
    case UFBldAddAIValueModTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)
        #define Value P(2)
        #define Divider P(3)

    float FValue = Value;
    AllBuildings[Bld].AddTechAIValueMod(TechID, FValue/(float)Divider);

        #undef Bld
        #undef TechID
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddProdAmountModTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)
        #define Value P(2)
        #define Divider P(3)

    float FValue = Value;
    AllBuildings[Bld].AddTechProdAmountMod(TechID, FValue/(float)Divider);

//    BldOutput.Print("  ProdAmountModTech \"%s\" %f\n", TechID, FValue / (float)Divider);

        #undef Bld
        #undef TechID
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddWorkersRequiredModTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)
        #define Value P(2)
        #define Divider P(3)

    float FValue = Value;
    AllBuildings[Bld].AddTechWorkersRequiredMod(TechID, FValue/(float)Divider);

        #undef Bld
        #undef TechID
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddRequiredResourceModTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)
        #define RType P(2)
        #define Value P(3)
        #define Divider P(4)

    float FValue = Value;
    AllBuildings[Bld].AddTechResourcesRequiredValueMod(TechID, RType, FValue/(float)Divider);

        #undef Bld
        #undef TechID
        #undef RType
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddConsumptionResourceModTechnology_:
      {
        #define Bld P(0)
        #define TechID PS(1)
        #define RType P(2)
        #define Value P(3)
        #define Divider P(4)

    float FValue = Value;
    AllBuildings[Bld].AddTechResourcesConsumptionValueMod(TechID, RType, FValue/(float)Divider);

        #undef Bld
        #undef TechID
        #undef RType
        #undef Value
        #undef Divider
        break;
      }
    case UFBldAddGroundUnitProduction_:
      {
        #define Bld P(0)
        #define UnitID PS(1)

    AllBuildings[Bld].SetGroundUnit(UnitID);

//    BldOutput.Print("  GroundUnit \"%s\"\n", UnitID);

        #undef Bld
        #undef UnitID
        break;
      }
    case UFBldGetProperty_:
      {
        #define Bld P(0)
        #define PropertyIndex P(1)

    Return(GetBit(AllBuildings[Bld].Properties, PropertyIndex));

        #undef Bld
        #undef PropertyIndex
        break;
      }
    case UFBldSkipSpecialCheckResourcesUntilProperty_:
      {
        #define Bld P(0)
        #define Property P(1)

    Return(AllBuildings[Bld].SkipSpecialCheckResourcesUntilProperty(Property));

        #undef Bld
        #undef Property
        break;
      }
    case UFGetNthSpecialCheckResourcesAfterProperty_:
      {
        #define Bld P(0)
        #define WRace P(1)
        #define Property P(2)
        #define Num P(3)
        #define Mult P(4)

    float Ret = 0.0f;
    int SkipCount = AllBuildings[Bld].SkipSpecialCheckResourcesUntilProperty(Property) + Num;
    
    for (int Ind = 0; Ind<AllBuildings[Bld].ProductionCount; Ind++)
    {
      if (AllRes[AllBuildings[Bld]._ProductionType[Ind]].RClass == rclassSpecialCheck)
      {
        if (SkipCount>0)
          SkipCount--;
        else
        {
          Ret = AllBuildings[Bld].GetProductionAmountInd(Ind, WRace) * (float)Mult;
          break;
        }
      }
    }

    Return((int)Ret);

        #undef Bld
        #undef WRace
        #undef Property
        #undef Num
        #undef Mult
        break;
      }
    case UFGetBldProductionAmount_:
      {
        #define Bld P(0)
        #define ResType P(1)
        #define WRace P(2)
        #define Mult P(3)

    Return((int)(AllBuildings[Bld].GetProductionAmount(ResType, WRace) * Mult));

        #undef Bld
        #undef ResType
        #undef WRace
        #undef Mult
        break;
      }
    case UFGetBldProductionTypes_:
      {
        #define Bld P(0)

    Return(AllBuildings[Bld].ProductionCount);

        #undef Bld
        break;
      }
    case UFGetBldProductionTypeIndexed_:
      {
        #define Bld P(0)
        #define Index P(1)

    Return(AllBuildings[Bld]._ProductionType[Index]);

        #undef Bld
        #undef Index
        break;
      }
    case UFGetBldProductionAmountIndexed_:
      {
        #define Bld P(0)
        #define Index P(1)
        #define WRace P(2)
        #define Mult P(3)

    Return((int)(AllBuildings[Bld].GetProductionAmountInd(Index, WRace) * Mult));

        #undef Bld
        #undef Index
        #undef WRace
        #undef Mult
        break;
      }
    case UFGetBldWorkersRequired_:
      {
        #define Bld P(0)
        #define WRace P(1)

    Return(AllBuildings[Bld].GetWorkersRequired(WRace));

        #undef Bld
        #undef WRace
        break;
      }
    case UFGetAIBldValue_:
      {
        #define Bld P(0)
        #define WRace P(1)
        #define Mult P(2)

    Return((int)(AllBuildings[Bld].GetAIValue(WRace)*Mult));

        #undef Bld
        #undef WRace
        #undef Mult
        break;
      }
    case UFBldGetRequiredResource_:
      {
        #define Bld P(0)
        #define RType P(1)
        #define WRace P(2)
        #define Mult P(3)

    Return((int)(AllBuildings[Bld].GetResourcesRequired(WRace, RType)*Mult));

        #undef Bld
        #undef RType
        #undef WRace
        #undef Mult
        break;
      }
    case UFBldGetResourceConsumption_:
      {
        #define Bld P(0)
        #define RType P(1)
        #define WRace P(2)
        #define Mult P(3)

    Return((int)(AllBuildings[Bld].GetResourcesConsumption(WRace, RType)*Mult));

        #undef Bld
        #undef RType
        #undef WRace
        #undef Mult
        break;
      }
    case UFBldAddAssimilationBooster_:
      {
        #define BoosterPercent P(0)
        #define TechName PS(1)

    Planet::AssimilationBoosters = new AssimilationHelperStruct(((float)BoosterPercent)/100.0f, Find_Technology(TechName), Planet::AssimilationBoosters);

        #undef BoosterPercent
        #undef TechName
        break;
      }
    case UFBldAddMayBuildRule_:
      {

    Planet::MayBuildRules = new MayBuildRuleStruct(Planet::MayBuildRules);
    Res = (LLong)Planet::MayBuildRules;

        break;
      }
    case UFBldCreateMayBuildRule_:
      {

    MayBuildRuleStruct *MBR = new MayBuildRuleStruct(NULL);
    Res = (LLong)MBR;

        break;
      }
    case UFBldMayBuildRuleAddBldCheck_:
      {
        #define MBRHandle P(0)
        #define BldType P(1)
        #define Coeff P(2)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->AddCheckBld(BldType, Coeff);

        #undef MBRHandle
        #undef BldType
        #undef Coeff
        break;
      }
    case UFBldMayBuildRuleAddMaxBldCheck_:
      {
        #define MBRHandle P(0)
        #define BldType P(1)
        #define Coeff P(2)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->AddCheckMaxBld(BldType, Coeff);

        #undef MBRHandle
        #undef BldType
        #undef Coeff
        break;
      }
    case UFBldMayBuildRuleAddComplexBldCheck_:
      {
        #define MBRHandle P(0)
        #define BldType P(1)
        #define BldType1 P(2)
        #define Max P(3)
        #define Negate P(4)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->AddCheckBldComplexCoeff(BldType, BldType1, (Yes_==Max), (Yes_==Negate));

        #undef MBRHandle
        #undef BldType
        #undef BldType1
        #undef Max
        #undef Negate
        break;
      }
    case UFBldMayBuildRuleAddComplexMaxBldCheck_:
      {
        #define MBRHandle P(0)
        #define BldType P(1)
        #define BldType1 P(2)
        #define Negate P(3)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->AddCheckMaxBldComplex(BldType, BldType1, (Yes_==Negate));

        #undef MBRHandle
        #undef BldType
        #undef BldType1
        #undef Negate
        break;
      }
    case UFBldMayBuildRuleAddCheckConst_:
      {
        #define MBRHandle P(0)
        #define Coeff P(1)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->AddCheckConst(Coeff);

        #undef MBRHandle
        #undef Coeff
        break;
      }
    case UFBldMayBuildRuleAddPreCheck_:
      {
        #define MBRHandle P(0)
        #define PreCheckRuleHandle P(1)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;
    ((MayBuildRuleStruct *)PreCheckRuleHandle)->Next = MBR->PreRule;
    MBR->PreRule = (MayBuildRuleStruct *)PreCheckRuleHandle;

        #undef MBRHandle
        #undef PreCheckRuleHandle
        break;
      }
    case UFBldMayBuildRuleSetExplanationEvent_:
      {
        #define MBRHandle P(0)
        #define EventText PS(1)

    MayBuildRuleStruct *MBR = (MayBuildRuleStruct *)MBRHandle;

    MBR->ExplanationEvent = EventText;

        #undef MBRHandle
        #undef EventText
        break;
      }
    case UFSwitchTutorialMode_:
      {
        #define SwitchOn P(0)

    TutorialMode = (Yes_==SwitchOn);

        #undef SwitchOn
        break;
      }
    case UFSetEventText_:
      {
        #define EventCode P(0)
        #define EventStr PS(1)

    TutorialEvent[EventCode].Event = (const char*)EventStr;

        #undef EventCode
        #undef EventStr
        break;
      }
    case UFSwitchEventOn_:
      {
        #define EventCode P(0)

    TutorialEvent[EventCode].SwitchedOn = true;

        #undef EventCode
        break;
      }
    case UFSwitchEventOff_:
      {
        #define EventCode P(0)

    TutorialEvent[EventCode].SwitchedOn = false;

        #undef EventCode
        break;
      }
    case UFShowGlowingMessage_:
      {
        #define Text PS(0)
        #define Font P(1)

    GlowingMessage::NewMessage((char*)(const char*)Text, NULL, NULL, (FontTypes)Font);
    GlowingMessage::RGB = colWhite;
    GlowingMessage::DrawBlackBackground = false;
    GlowingMessage::Additive = false;

        #undef Text
        #undef Font
        break;
      }
    case UFGlowingMessageAddText_:
      {
        #define Text PS(0)

    for (int i = 0; i<3; i++)
    {
      if (GlowingMessage::InfoTextSize[i]<=0.0f)
      {
        strcpy(GlowingMessage::InfoText[i], (const char*)Text);
        GlowingMessage::InfoTextSize[i] = GetTextWidth(GlowingMessage::InfoText[i], GlowingMessage::fnt);
        break;
      }
    }

        #undef Text
        break;
      }
    case UFSetGlowingMessageColor_:
      {
        #define R P(0)
        #define G P(1)
        #define B P(2)

    GlowingMessage::RGB = al_map_rgb(R, G, B);

        #undef R
        #undef G
        #undef B
        break;
      }
    case UFGlowingMessageBackground_:
      {
        #define DoDraw P(0)

    GlowingMessage::DrawBlackBackground = (Yes_==DoDraw);

        #undef DoDraw
        break;
      }
    case UFGlowingMessageAdditive_:
      {
        #define DoDraw P(0)

    GlowingMessage::Additive = (Yes_==DoDraw);

        #undef DoDraw
        break;
      }
    case UFGlowingMessageAddTime_:
      {
        #define Time P(0)

    GlowingMessage::TargetTick+=Time;

        #undef Time
        break;
      }
    case UFShowFullScreenMessage_:
      {
        #define Text PS(0)
        #define _DimScreen P(1)
        #define _ShowOK P(2)
        #define AllowScroll P(3)

    FullScreenMessage::SetText((const char*)Text, Yes_==_DimScreen);
    FullScreenMessage::ShowOK = (Yes_==_ShowOK);
    FullScreenMessage::ScrollAllowed = (Yes_==AllowScroll);
    FullScreenMessage::UseNoDimRegion = false;
    FullScreenMessage::UseArrow = false;
    FullScreenMessage::MoveAwayFromMouse = false;
    FullScreenMessage::TheOnlyButtonAllowed = NULL;

        #undef Text
        #undef _DimScreen
        #undef _ShowOK
        #undef AllowScroll
        break;
      }
    case UFFullScreenMessageAddNextText_:
      {
        #define Text PS(0)

    FullScreenMessage::AddNextText((const char*)Text);

        #undef Text
        break;
      }
    case UFSetFullScreenMessageHeader_:
      {
        #define NewHeader PS(0)

    strcpy(FullScreenMessage::Header, (const char*)NewHeader);

        #undef NewHeader
        break;
      }
    case UFClearFullScreenMessage_:
      {

    FullScreenMessage::Clear();

        break;
      }
    case UFShowFullScreenMessageSmallFont_:
      {

    FullScreenMessage::SmallFont = true;

        break;
      }
    case UFShowFullScreenMessageWideWindow_:
      {

    FullScreenMessage::WideWindow = true;

        break;
      }
    case UFShowFullScreenMessageMoveAwayFromMouse_:
      {

    FullScreenMessage::NoDimRegionStar = NULL;
    FullScreenMessage::NoDimRegionFleet = NULL;
    FullScreenMessage::NoDimRegionBatShip = NULL;
    FullScreenMessage::MoveAwayFromMouse = true;
    FullScreenMessage::UseNoDimRegion = true;

        break;
      }
    case UFSetNoDimRegion_:
      {
        #define StartX P(0)
        #define StartY P(1)
        #define SizeX P(2)
        #define SizeY P(3)

    FullScreenMessage::NoDimRegion = E1Rectangle(StartX, StartY, StartX+SizeX, StartY+SizeY);
    FullScreenMessage::NoDimRegionStar = NULL;
    FullScreenMessage::NoDimRegionFleet = NULL;
    FullScreenMessage::NoDimRegionBatShip = NULL;
    FullScreenMessage::MoveAwayFromMouse = false;
    FullScreenMessage::UseNoDimRegion = true;

        #undef StartX
        #undef StartY
        #undef SizeX
        #undef SizeY
        break;
      }
    case UFSetNoDimRegionByStar_:
      {
        #define StarHandle P(0)

    FullScreenMessage::NoDimRegionStar = (Star*)StarHandle;
    FullScreenMessage::NoDimRegionFleet = NULL;
    FullScreenMessage::NoDimRegionBatShip = NULL;
    FullScreenMessage::MoveAwayFromMouse = false;
    FullScreenMessage::UseNoDimRegion = true;

        #undef StarHandle
        break;
      }
    case UFSetNoDimRegionByFleet_:
      {
        #define FleetHandle P(0)

    FullScreenMessage::NoDimRegionStar = NULL;
    FullScreenMessage::NoDimRegionFleet = (Fleet*)FleetHandle;
    FullScreenMessage::NoDimRegionBatShip = NULL;
    FullScreenMessage::MoveAwayFromMouse = false;
    FullScreenMessage::UseNoDimRegion = true;

        #undef FleetHandle
        break;
      }
    case UFSetNoDimRegionByBatShip_:
      {
        #define ShipHandle P(0)

    FullScreenMessage::NoDimRegionStar = NULL;
    FullScreenMessage::NoDimRegionFleet = NULL;
    FullScreenMessage::NoDimRegionBatShip = (spaceship*)ShipHandle;
    FullScreenMessage::MoveAwayFromMouse = false;
    FullScreenMessage::UseNoDimRegion = true;

        #undef ShipHandle
        break;
      }
    case UFSetNoDimByElement_:
      {
        #define Name PS(0)

    if (!strcmp("events monitor", Name))
    {
      FullScreenMessage::NoDimRegion = E1Rectangle(EventsMonitor::LastDrawX, EventsMonitor::LastDrawY, EventsMonitor::LastDrawX + EventsMonitor::LastSizeX, EventsMonitor::LastDrawY + EventsMonitor::LastSizeY);
      FullScreenMessage::UseNoDimRegion = true;
    }
    else
    {
      if (!strcmp("global map", Name))
      {
        FullScreenMessage::NoDimRegion = E1Rectangle(Galaxy::SegVis->WindowStartX, Galaxy::SegVis->WindowStartY, Galaxy::SegVis->WindowStartX + Galaxy::SegVis->FitWindowSizeX, Galaxy::SegVis->WindowStartY + Galaxy::SegVis->FitWindowSizeY);
        FullScreenMessage::UseNoDimRegion = true;
      }
      else
      {
        E1WinElement *Element = NULL;

        if (WinElementSearch)
          Element = (E1WinElement *)WinElementSearch((const char*)Name, Bit(saSearch));

        if (Element)
        {
          FullScreenMessage::NoDimRegion = E1Rectangle(Element->DrawX, Element->DrawY, Element->DrawX+Element->SizeX, Element->DrawY+Element->SizeY);
          FullScreenMessage::UseNoDimRegion = true;
        }
      }
    }

    FullScreenMessage::NoDimRegionStar = NULL;
    FullScreenMessage::NoDimRegionFleet = NULL;
    FullScreenMessage::NoDimRegionBatShip = NULL;
    FullScreenMessage::MoveAwayFromMouse = false;

        #undef Name
        break;
      }
    case UFSetArrowTarget_:
      {
        #define TargetX P(0)
        #define TargetY P(1)

    FullScreenMessage::ArrowTarget = Point(TargetX, TargetY);
    FullScreenMessage::ArrowTargetFleet = NULL;
    FullScreenMessage::ArrowTargetStar = NULL;
    FullScreenMessage::ArrowTargetElement = NULL;
    FullScreenMessage::ArrowTargetBatShip = NULL;
    FullScreenMessage::UseArrow = true;

        #undef TargetX
        #undef TargetY
        break;
      }
    case UFSetArrowTargetFleet_:
      {
        #define FleetHandle P(0)

    FullScreenMessage::ArrowTargetFleet = (Fleet*)FleetHandle;
    FullScreenMessage::ArrowTargetStar = NULL;
    FullScreenMessage::ArrowTargetElement = NULL;
    FullScreenMessage::ArrowTargetBatShip = NULL;
    FullScreenMessage::UseArrow = true;

        #undef FleetHandle
        break;
      }
    case UFSetArrowTargetStar_:
      {
        #define StarHandle P(0)

    FullScreenMessage::ArrowTargetFleet = NULL;
    FullScreenMessage::ArrowTargetStar = (Star*)StarHandle;
    FullScreenMessage::ArrowTargetElement = NULL;
    FullScreenMessage::ArrowTargetBatShip = NULL;
    FullScreenMessage::UseArrow = true;

        #undef StarHandle
        break;
      }
    case UFSetArrowTargetElement_:
      {
        #define ElementHandle P(0)

    FullScreenMessage::ArrowTargetElement = (E1WinElement *)ElementHandle;
    FullScreenMessage::ArrowTargetFleet = NULL;
    FullScreenMessage::ArrowTargetStar = NULL;
    FullScreenMessage::ArrowTargetBatShip = NULL;
    FullScreenMessage::UseArrow = true;

        #undef ElementHandle
        break;
      }
    case UFSetArrowTargetBatShip_:
      {
        #define ShipHandle P(0)

    FullScreenMessage::ArrowTargetElement = NULL;
    FullScreenMessage::ArrowTargetFleet = NULL;
    FullScreenMessage::ArrowTargetStar = NULL;
    FullScreenMessage::ArrowTargetBatShip = (spaceship*)ShipHandle;
    FullScreenMessage::UseArrow = true;

        #undef ShipHandle
        break;
      }
    case UFSetArrowTargetByElement_:
      {
        #define Name PS(0)
        #define TargetCenter P(1)

    if (!strcmp("red cell", Name))
    {
      FullScreenMessage::UseArrow = DesignEditorGetRedCell(FullScreenMessage::ArrowTarget);
    }
    else
    {
      if (!strcmp("blue cell", Name))
      {
        FullScreenMessage::UseArrow = DesignEditorGetBlueCell(FullScreenMessage::ArrowTarget);
      }
      else
      {
        if (!strcmp("fundamental science section", Name))
        {
          E1Rectangle ElementRect;

          GetFundamentalScienceRect(ElementRect);

          if (Yes_==TargetCenter || !ElementRect.IntersectsPoint(Point(Screen.Size.x/2, Screen.Size.y/2), (ElementRect.Origin + ElementRect.Corner)/2, FullScreenMessage::ArrowTarget))
            FullScreenMessage::ArrowTarget = (ElementRect.Origin + ElementRect.Corner)/2;

          FullScreenMessage::UseArrow = true;
        }
        else
        {
          if (!strcmp("applied science section", Name))
          {
            E1Rectangle ElementRect;

            GetAppliedScienceRect(ElementRect);

            if (Yes_==TargetCenter || !ElementRect.IntersectsPoint(Point(Screen.Size.x/2, Screen.Size.y/2), (ElementRect.Origin + ElementRect.Corner)/2, FullScreenMessage::ArrowTarget))
              FullScreenMessage::ArrowTarget = (ElementRect.Origin + ElementRect.Corner)/2;

            FullScreenMessage::UseArrow = true;
          }
          else
          {
            if (!strcmp("science split scroller", Name))
            {
              E1Rectangle ElementRect;

              GetScienceSplitScrollerRect(ElementRect);

              if (Yes_==TargetCenter || !ElementRect.IntersectsPoint(Point(Screen.Size.x/2, Screen.Size.y/2), (ElementRect.Origin + ElementRect.Corner)/2, FullScreenMessage::ArrowTarget))
                FullScreenMessage::ArrowTarget = (ElementRect.Origin + ElementRect.Corner)/2;

              FullScreenMessage::UseArrow = true;
            }
            else
            {
              if (!strcmp("events monitor", Name))
              {
                E1Rectangle ElementRect(EventsMonitor::LastDrawX, EventsMonitor::LastDrawY, EventsMonitor::LastDrawX + EventsMonitor::LastSizeX, EventsMonitor::LastDrawY + EventsMonitor::LastSizeY);

                if (Yes_==TargetCenter || !ElementRect.IntersectsPoint(Point(Screen.Size.x/2, Screen.Size.y/2), Point(EventsMonitor::LastDrawX + EventsMonitor::LastSizeX/2.0f, EventsMonitor::LastDrawY + EventsMonitor::LastSizeY/2.0f), FullScreenMessage::ArrowTarget))
                  FullScreenMessage::ArrowTarget = Point(EventsMonitor::LastDrawX + EventsMonitor::LastSizeX/2.0f, EventsMonitor::LastDrawY + EventsMonitor::LastSizeY/2.0f);

                FullScreenMessage::UseArrow = true;
              }
              else
              {
                E1WinElement *Element = NULL;

                if (WinElementSearch)
                  Element = (E1WinElement *)WinElementSearch((const char*)Name, Bit(saSearch));

                if (Element)
                {
                  if (Yes_==TargetCenter)
                  {
                    if (Element->PositionedByCenter)
                      FullScreenMessage::ArrowTarget = Point(Element->DrawX, Element->DrawY);
                    else
                      FullScreenMessage::ArrowTarget = Point(Element->DrawX+Element->SizeX/2, Element->DrawY+Element->SizeY/2);
                  }
                  else
                  {
                    E1Rectangle ElementRect(Element->DrawX, Element->DrawY, Element->DrawX+Element->SizeX, Element->DrawY+Element->SizeY);

                    Point EndPoint(Element->DrawX+Element->SizeX/2, Element->DrawY+Element->SizeY/2);
                    
                    if (Element->PositionedByCenter)
                    {
                      ElementRect.Origin-=Point(Element->SizeX/2, Element->SizeY/2);
                      ElementRect.Corner-=Point(Element->SizeX/2, Element->SizeY/2);
                      
                      EndPoint-=Point(Element->SizeX/2, Element->SizeY/2);
                    }

                    if (!ElementRect.IntersectsPoint(Point(Screen.Size.x/2, Screen.Size.y/2), EndPoint, FullScreenMessage::ArrowTarget))
                    {
                      if (Element->PositionedByCenter)
                        FullScreenMessage::ArrowTarget = Point(Element->DrawX, Element->DrawY);
                      else
                        FullScreenMessage::ArrowTarget = Point(Element->DrawX+Element->SizeX/2, Element->DrawY+Element->SizeY/2);
                    }
                  }

                  FullScreenMessage::UseArrow = true;
                }
              }
            }
          }
        }
      }
    }

    FullScreenMessage::ArrowTargetElement = NULL;
    FullScreenMessage::ArrowTargetFleet = NULL;
    FullScreenMessage::ArrowTargetStar = NULL;
    FullScreenMessage::ArrowTargetBatShip = NULL;

        #undef Name
        #undef TargetCenter
        break;
      }
    case UFGetWinElementByName_:
      {
        #define Name PS(0)

    LLong Result = 0;
    
    if (WinElementSearch)
      Result = WinElementSearch((const char*)Name, Bit(saSearch));
    
    Return(Result)

        #undef Name
        break;
      }
    case UFGetWinElementDrawX_:
      {
        #define ElementHandle P(0)

    E1WinElement *Element = (E1WinElement *)ElementHandle;

    if (Element)
    {
      Return(Element->DrawX)
    }
    else
    {
      Return(0)
    }

        #undef ElementHandle
        break;
      }
    case UFGetWinElementDrawY_:
      {
        #define ElementHandle P(0)

    E1WinElement *Element = (E1WinElement *)ElementHandle;

    if (Element)
    {
      Return(Element->DrawY)
    }
    else
    {
      Return(0)
    }

        #undef ElementHandle
        break;
      }
    case UFGetWinElementSizeX_:
      {
        #define ElementHandle P(0)

    E1WinElement *Element = (E1WinElement *)ElementHandle;

    if (Element)
    {
      Return(Element->SizeX)
    }
    else
    {
      Return(Screen.Size.x)
    }

        #undef ElementHandle
        break;
      }
    case UFGetWinElementSizeY_:
      {
        #define ElementHandle P(0)

    E1WinElement *Element = (E1WinElement *)ElementHandle;

    if (Element)
    {
      Return(Element->SizeY)
    }
    else
    {
      Return(Screen.Size.y)
    }

        #undef ElementHandle
        break;
      }
    case UFDisableWinElement_:
      {
        #define Name PS(0)

//    if (!strcmp(Name, "planet preview"))
//      PlanetClickDisabledByTutorial = true;
//    else
    {
      if (!strcmp(Name, "global clocks"))
        E1Clocks::ClickDisabledByTutorial = true;
      else
      {
        if (!strcmp(Name, "events monitor"))
          EventsMonitor::DisableAsWinElement();
        else
        {
          E1WinElement *Element = NULL;

          if (WinElementSearch)
            Element = (E1WinElement *)WinElementSearch((const char*)Name, Bit(saSearch));

          if (Element)
            Element->ClickDisabledByTutorial = true;
        }
      }
    }

        #undef Name
        break;
      }
    case UFEnableWinElement_:
      {
        #define Name PS(0)

//    if (!strcmp(Name, "planet preview"))
//      PlanetClickDisabledByTutorial = false;
//    else
    {
      if (!strcmp(Name, "global clocks"))
        E1Clocks::ClickDisabledByTutorial = false;
      else
      {
        if (!strcmp(Name, "events monitor"))
          EventsMonitor::EnableAsWinElement();
        else
        {
          E1WinElement *Element = NULL;

          if (WinElementSearch)
            Element = (E1WinElement *)WinElementSearch((const char*)Name, Bit(saSearch));

          if (Element)
            Element->ClickDisabledByTutorial = false;
        }
        }
    }

        #undef Name
        break;
      }
    case UFEnableAllWinElements_:
      {

    if (WinElementSearch)
      WinElementSearch("", Bit(saEnable));

    E1Clocks::ClickDisabledByTutorial = false;
    EventsMonitor::EnableAsWinElement();
//    PlanetClickDisabledByTutorial = false;

        break;
      }
    case UFDisableAllWinElements_:
      {

    if (WinElementSearch)
      WinElementSearch("", Bit(saDisable));

    E1Clocks::ClickDisabledByTutorial = true;
    EventsMonitor::DisableAsWinElement();
//    PlanetClickDisabledByTutorial = true;

        break;
      }
    case UFSetOnlyOneAllowedWinElement_:
      {
        #define Name PS(0)

    if (WinElementSearch)
      WinElementSearch("", Bit(saDisable));
    
    EventsMonitor::DisableAsWinElement();
    E1Clocks::ClickDisabledByTutorial = true;
//    PlanetClickDisabledByTutorial = true;

    if (!strcmp("events monitor", Name))
    {
      FullScreenMessage::TheOnlyButtonAllowed = &E1WinElement::VirtualControl;

      E1WinElement::VirtualControl.DrawX = EventsMonitor::LastDrawX;
      E1WinElement::VirtualControl.DrawY = EventsMonitor::LastDrawY;
      E1WinElement::VirtualControl.SizeX = EventsMonitor::LastSizeX;
      E1WinElement::VirtualControl.SizeY = EventsMonitor::LastSizeY;
      
      EventsMonitor::EnableAsWinElement();
    }
    else
    {
      if (!strcmp("global map", Name))
      {
        FullScreenMessage::TheOnlyButtonAllowed = &E1WinElement::VirtualControl;

        E1WinElement::VirtualControl.DrawX = Galaxy::SegVis->WindowStartX;
        E1WinElement::VirtualControl.DrawY = Galaxy::SegVis->WindowStartY;
        E1WinElement::VirtualControl.SizeX = Galaxy::SegVis->FitWindowSizeX;
        E1WinElement::VirtualControl.SizeY = Galaxy::SegVis->FitWindowSizeY;
      }
      else
      {
        if (WinElementSearch)
          FullScreenMessage::TheOnlyButtonAllowed = (E1WinElement *)WinElementSearch((const char*)Name, Bit(saSearch));
      }
    }
    
    if (FullScreenMessage::TheOnlyButtonAllowed)
      FullScreenMessage::TheOnlyButtonAllowed->ClickDisabledByTutorial = false;

        #undef Name
        break;
      }
    case UFSetOnlyOneAllowedRegion_:
      {
        #define StartX P(0)
        #define StartY P(1)
        #define _SizeX P(2)
        #define _SizeY P(3)

    if (WinElementSearch)
      WinElementSearch("", Bit(saDisable));
    
    EventsMonitor::DisableAsWinElement();
    E1Clocks::ClickDisabledByTutorial = true;
//    PlanetClickDisabledByTutorial = true;

    FullScreenMessage::TheOnlyButtonAllowed = &E1WinElement::VirtualControl;

    E1WinElement::VirtualControl.DrawX = StartX;
    E1WinElement::VirtualControl.DrawY = StartY;
    E1WinElement::VirtualControl.SizeX = _SizeX;
    E1WinElement::VirtualControl.SizeY = _SizeY;

        #undef StartX
        #undef StartY
        #undef _SizeX
        #undef _SizeY
        break;
      }
    case UFSetEventsMonitorDisableParts_:
      {
        #define _DisableAccept P(0)
        #define _DisableClose P(1)
        #define _DisableCloseAndContinue P(2)

  EventsMonitor::AcceptDisabledByTutorial = (Yes_==_DisableAccept);
  EventsMonitor::CloseDisabledByTutorial = (Yes_==_DisableClose);
  EventsMonitor::CloseAndContinueDisabledByTutorial = (Yes_==_DisableCloseAndContinue);

        #undef _DisableAccept
        #undef _DisableClose
        #undef _DisableCloseAndContinue
        break;
      }
    case UFEnableAllKeys_:
      {

    EnableAllKeys();

        break;
      }
    case UFDisableAllKeys_:
      {

    DisableAllKeys();

        break;
      }
    case UFEnableKey_:
      {
        #define Name PS(0)

    int ID = GetKeyCodeByName((char*)(const char*)Name);
    
    if (ID!=E1_UNDEFINED)
      KeyDisabled[ID] = false;

        #undef Name
        break;
      }
    case UFDisableKey_:
      {
        #define Name PS(0)

    int ID = GetKeyCodeByName((char*)(const char*)Name);
    
    if (ID!=E1_UNDEFINED)
      KeyDisabled[ID] = true;

        #undef Name
        break;
      }
    case UFRestrictBuildShip_:
      {
        #define OnlyName PS(0)

    SetRestrictBuildShip((const char*)OnlyName);

        #undef OnlyName
        break;
      }
    case UFCancelRestrictBuildShip_:
      {

    SetRestrictBuildShip(NULL);

        break;
      }
    case UFDisableRightClick_:
      {

    TutorialRightClickEnabled = false;

        break;
      }
    case UFEnableRightClick_:
      {

    TutorialRightClickEnabled = true;

        break;
      }
    case UFDisableRightClickMenu_:
      {

    TutorialRightClickMenuEnabled = false;

        break;
      }
    case UFEnableRightClickMenu_:
      {

    TutorialRightClickMenuEnabled = true;

        break;
      }
    case UFSwitchDesignerTabArmour_:
      {

    DesignEditorTabArmour();

        break;
      }
    case UFSwitchDesignerTabEngines_:
      {

    DesignEditorTabEngines();

        break;
      }
    case UFSwitchDesignerTabWeapon_:
      {

    DesignEditorTabWeapon();

        break;
      }
    case UFSwitchDesignerTabShields_:
      {

    DesignEditorTabShields();

        break;
      }
    case UFSwitchDesignerTabGenerators_:
      {

    DesignEditorTabGenerators();

        break;
      }
    case UFSwitchDesignerTabSpecial_:
      {

    DesignEditorTabSpecial();

        break;
      }
    case UFSwitchDesignerSelectItemFromTab_:
      {

    SelectFirstItemFromTab();

        break;
      }
    case UFInitPlanetSelectionPrompt_:
      {

    GalaxyInitSelectPlanetPrompt();

        break;
      }
    case UFAddPlanetToSelectionPrompt_:
      {
        #define PlanetHandle P(0)

    GalaxyAddPlanetToSelectionPrompt((Planet*)PlanetHandle);

        #undef PlanetHandle
        break;
      }
    case UFExecutePlanetSelectionPrompt_:
      {
        #define Prompt PS(0)
        #define x P(1)
        #define y P(2)

    // if x and y are -1, then the current mouse cursor coordinates are used
    Return((LLong)GalaxySelectPlanetPrompt((char*)(const char*)Prompt, x, y));

        #undef Prompt
        #undef x
        #undef y
        break;
      }
    case UFBatFirstSelected_:
      {

    Return( CheckFirstSelected() ? Yes_ : No_)

        break;
      }
    case UFBatGetShipDesign_:
      {
        #define ShipHandle P(0)

    Return(GetBatShipDesign((spaceship*)ShipHandle))

        #undef ShipHandle
        break;
      }
    case UFBatGetShipMissilesCount_:
      {
        #define ShipHandle P(0)

    Return(GetBatShipMissilesCount((spaceship*)ShipHandle))

        #undef ShipHandle
        break;
      }
    case UFBatCenterOnShip_:
      {
        #define ShipHandle P(0)

    CenterShip((spaceship*)ShipHandle);

        #undef ShipHandle
        break;
      }
    case UFBatShipVisibleOnScreen_:
      {
        #define ShipHandle P(0)

    Return(ShipVisibleOnScreen((spaceship*)ShipHandle) ? Yes_ : No_)

        #undef ShipHandle
        break;
      }
    case UFPlaceShip_:
      {
        #define ShipHandle P(0)
        #define x P(1)
        #define y P(2)

    // note, this does not update hash! better to use only for initial ship placement as a reaction to evBatInitialPlacementDone
    BatShipPlace((spaceship*)ShipHandle, x, y);

        #undef ShipHandle
        #undef x
        #undef y
        break;
      }
    default:
      {
        ErrorMessage("Unknown", erCompiler, "Error in UserFunc: unknown IDCode %i\n", IDCode);
        Res = 0;
        break;
      }
  }

}
#undef P
#undef PS
#undef Res

//Warning!!! All variables mentioned here should be declared somewhere.

void InitExternalFlagsA()
{
}

void RestoreExternalFlagsA()
{
}
